
var controller = {
		
};
var storage = {};
var states = {};
var view = {};
var webshares = {};
var search = {
	searchResultFolder : null, //folders from the search result
	searchResultFiles : null, //files from the search result
	searchQuery : null
};
var modelCode;

// this variables manage the path in the cloud system
var route = new Array();
var folderRoute = new Array();
var favoritesRoute = new Array();
var folderOrder = true;

var NNaviPlugin;
var numberFilesRequest = 100; // numebr of files in each request to server
var numberPreLoad = 1;  // Number of images to preload in image scene
var videoBufferSize = 100 * 1024; // 1000KB
var audioBufferSize = 400 * 1024; // 1000KB

var bitRate = 0.0;
var networks;

var pluginAPI;
var networkPlugin;
var internetConnectionInterval; // interval time to check network connected
var internetConnectionPopup = false;

var host = 'http://www.cloudme.com';
//host = 'http://www.devs004.intra';

controller.initialize = function () {
	alert("controller.initialize()");
	NNaviPlugin = sf.core.plugin('NNAVI');
	modelCode = NNaviPlugin.GetModelCode();
	pluginAPI = new Common.API.Plugin();
	controller.registerKeys();
	

}

controller.onNetworkStatusChange = function (status) {
	alert("Network Status : " + status.code + " " + status.msg);
	$('#error_popup').sfPopup({
		text : "Network Status : " + status.code + " " + status.msg,
		buttons : "OK"
	});
	$('#error_popup').sfPopup('show');
}

controller.start = function () {
	alert("controller.start()");

	// Initialize network plugin 
	networkPlugin = document.getElementById('pluginObjectNetwork');
	internetConnectionInterval = 2000;

  //dynamic load of js files
	sf.core.loadJS('app/storage.js', function () {
		sf.core.loadJS('app/utils.js', function () {
			if (storage.getValue("keepLoggedIn") == "yes") { //Check if credentials stored and log in if found
				sf.core.loadJS('app/baxide.js', function () {
					sf.core.loadJS('app/Model.js', function () {
						model.startLogin(storage.getValue("loginUsername"), storage.getValue("loginToken"), "yes");
					});
				});
			} else {
				sf.scene.show('LoginScene');
				sf.scene.focus('LoginScene');
				loadFiles(); // load JS files asynchronusly once the scene is shown
			}
		});
	});

	
  //estimation of network speed
  var i = 1;
	(function loop() {
		setTimeout(function () {

			if (i <= 10) {

				controller.getNetworkSpeed(i);
				i++;
				alert(i);
				loop();
			}

		}, 500);
	})();
  
	setInterval("controller.cyclicInternetConnectionCheck();", internetConnectionInterval); // check netwrok connection every internetConnectionInterval

}

/**
*
* Download an image from cloudme and read the time needed
*/

controller.getNetworkSpeed = function (i) {
	var imageAddr = "http://www.cloudme.com/images/CloudMe_Blue2_Top.png" + "?n=" + Math.random();
	var startTime,
	endTime;
	var downloadSize = 42604;
	var download = document.createElement("img");
	var speedMbps;
	download.onload = function () {
		endTime = (new Date()).getTime();
		showResults(i);
		download = null;
		delete(download);
	}
	download.onerror = function () {
		alert("Error downloading img");
	}
	startTime = (new Date()).getTime();
	//	alert("startTime: "+startTime);
	download.src = imageAddr;

	function showResults(i) {
		var duration = (endTime - startTime) / 1000;
		alert("duration: " + duration);
		var bitsLoaded = downloadSize * 8;
		var speedBps = Math.round(bitsLoaded / duration);
		var speedKbps = (speedBps / 1024);
		speedMbps = (speedKbps / 1024);
		alert("Your connection speed is: \n" +
			speedBps + " bps\n" +
			speedKbps + " kbps\n" +
			speedMbps + " Mbps\n");
		bitRate = bitRate + speedMbps;
		if (i == 10) {
			controller.setParams();
		}
	}

}

/**
*
*Checks internet connection cyclic
*/
controller.cyclicInternetConnectionCheck = function () {
	alert("check network error");
	if (!controller.checkConnection()) {
		// no internet connection
		if (!internetConnectionPopup) {
			controller.showInternetConnectionPopup();
			try {
				PlayerPlugin.Pause();
				if (playingAudio) {
					$("#musicPlay").attr("src", "images/control/media_play.png");
					$("#musicPause").attr("src", "images/control/media_pause_red.png");
				}

			} catch (e) {
				alert("cant pause player plugin: " + e);
			}
		}
	} else {
		// if error message was shown, it should be returned back to normal

		if (internetConnectionPopup) {
			$("#error_popup").sfPopup('hide');
			internetConnectionPopup = false;
			// return to normal screen
		}
	}
}
//Cheack network connection
controller.checkConnection = function () {
	var physicalConnection = 0;
	var httpStatus = 0;

	// Get active connection type - wired or wireless.
	currentInterface = networkPlugin.GetActiveType();

	// If no active connection.
	if (currentInterface === -1) {
		return false;
	}

	// Check physical connection of current interface.
	physicalConnection = networkPlugin.CheckPhysicalConnection(currentInterface);

	// If not connected or error.
	if (physicalConnection !== 1) {
		return false;
	}

	// Check HTTP transport.
	httpStatus = networkPlugin.CheckHTTP(currentInterface);

	// If HTTP is not avaliable.
	if (httpStatus !== 1) {
		return false;
	}

	// Everything went OK.
	return true;
};

//Show the netowork connection popup
controller.showInternetConnectionPopup = function () {
	var popUpId = "";
	if (sf.scene.getFocused('LoginScene')) {
		popUpId = "#login_error_popup";
	}
	if (sf.scene.getFocused('DriveScene')) {
		popUpId = "#error_popup";
	}
	if (sf.scene.getFocused('VideoScene')) {
		popUpId = "#video_error_popup";
	}
	if (sf.scene.getFocused('ImageScene')) {
		popUpId = "#image_error_popup";
	}
	if (sf.scene.getFocused('WebSharesScene')) {
		popUpId = "#ws_error_popup";
	}
	if (sf.scene.getFocused('PlayQueueScene')) {
		popUpId = "#pq_error_popup";
	}
	if (sf.scene.getFocused('SignUpScene')) {
		popUpId = "#siup_error_popup";
	}
	if (sf.scene.getFocused('FolderScene')) {
		popUpId = "#folder_error_popup";
	}
	$(popUpId).sfPopup({
		text : "Network disconnected",
		buttons : [STR_OK],
		defaultFocus : 0,
		callback : function newFolderCallback() {
			internetConnectionPopup = false;
		}
	});
	$(popUpId).sfPopup('show');
	internetConnectionPopup = true;

};

/**
 *  
 */
controller.registerKeys = function(){
	//pluginAPI.registAllKey();
	//pluginAPI.unregistKey(sf.key.POWER);
	sf.key.registerKey(sf.key.LEFT);
	sf.key.registerKey(sf.key.RIGHT);
	sf.key.registerKey(sf.key.UP);
	sf.key.registerKey(sf.key.DOWN);
	sf.key.registerKey(sf.key.RETURN);
	sf.key.registerKey(sf.key.BLUE);
	sf.key.registerKey(sf.key.RED);
	sf.key.registerKey(sf.key.YELLOW);
	sf.key.registerKey(sf.key.GREEN);
	sf.key.registerKey(sf.key.N0);
	sf.key.registerKey(sf.key.N1);
	sf.key.registerKey(sf.key.N2);
	sf.key.registerKey(sf.key.N3);
	sf.key.registerKey(sf.key.N4);
	sf.key.registerKey(sf.key.N5);
	sf.key.registerKey(sf.key.N6);
	sf.key.registerKey(sf.key.N7);
	sf.key.registerKey(sf.key.N8);
	sf.key.registerKey(sf.key.N9);
	sf.key.registerKey(sf.key.VOL_UP);
	sf.key.registerKey(sf.key.VOL_DOWN);
	sf.key.registerKey(sf.key.MUTE);
	sf.key.registerKey(sf.key.ENTER);
	sf.key.registerKey(sf.key.EXIT);
	sf.key.registerKey(sf.key.REW);
	sf.key.registerKey(sf.key.PAUSE);
	sf.key.registerKey(sf.key.FF);
	sf.key.registerKey(sf.key.STOP);
	sf.key.registerKey(sf.key.PLAY);
	sf.key.registerKey(sf.key.INFO);
}


controller.registerArrowKeys = function(){
	//pluginAPI.registAllKey();
	//pluginAPI.unregistKey(sf.key.POWER);
	sf.key.registerKey(sf.key.LEFT);
	sf.key.registerKey(sf.key.RIGHT);
	sf.key.registerKey(sf.key.UP);
	sf.key.registerKey(sf.key.DOWN);
}

controller.unregisterArrowKeys = function(){
	//pluginAPI.registAllKey();
	//pluginAPI.unregistKey(sf.key.POWER);
	sf.key.unregisterKey(sf.key.LEFT);
	sf.key.unregisterKey(sf.key.RIGHT);
	sf.key.unregisterKey(sf.key.UP);
	sf.key.unregisterKey(sf.key.DOWN);
}

/**
*
* Set params according to network speed
**/
controller.setParams = function () {
	alert("bitRate: " + bitRate);
	bitRate = bitRate / 10;
	alert("bitRate: " + bitRate);
	if (bitRate < 1) {
		numberFilesRequest = 40; //40
		numberPreLoad = 8;
		videoBufferSize = 5 * 1024 * 1024; //in bytes 5MB
		audioBufferSize = 20 * 1024; //in bytes
	} else {
		if (bitRate < 3) {
			numberFilesRequest = 60; //60
			numberPreLoad = 4;
			videoBufferSize = 3 * 1024 * 1024; //in bytes 3MB
			audioBufferSize = 10 * 1024; //in bytes
		} else {
			if (bitRate < 6) {
				numberFilesRequest = 80;//80
				numberPreLoad = 3;
				videoBufferSize = 2 * 1024 * 1024; //in bytes 2MB
				audioBufferSize = 20 * 1024; //in bytes
			} else {
				if (bitRate < 10) {
					numberFilesRequest = 100;//100
					numberPreLoad = 2;
					videoBufferSize = 1 * 1024 * 1024; //in bytes 1MB
					audioBufferSize = 400 * 1024; //in bytes
				} else {
					numberFilesRequest = 120;//120
					numberPreLoad = 1;
					videoBufferSize = 0.5 * 1024 * 1024; //in bytes 512KB
					audioBufferSize = 400 * 1024; //in bytes
				}
			}
		}
	}
	//videoBufferSize = Math.floor(bitRate * 10 / 8);
}


controller.handleLogin = function (username, password, keepLogged) {
	alert("Handling Login");
	password = utils.MD5(username + ":os@xcerion.com:" + password); // create password token
	var remMe;
	if(keepLogged != undefined)
		remMe = keepLogged;
	else
		remMe = $('#SceneLogin #keeplogin_checkbox').sfCheckBox('getChecked');

	model.startLogin(username, password, remMe);
}

//Load JS files dynamically to the controller. --> Decrease application launch time
function importCallback(src) {
	alert("window.baxide: " + window.baxide);
	alert("window.model: " + window.model);
	alert("window.utils: " + window.utils);

}

/**
*
*  Loads js files that are not loaded yet
*/
function loadFiles() {
  if (window.baxide === undefined) {
		sf.core.loadJS("app/baxide.js", importCallback)
	};
	if (window.model === undefined) {
		sf.core.loadJS("app/Model.js", importCallback)
	};
	if (window.utils === undefined) {
		sf.core.loadJS("app/Utils.js", importCallback)
	};

}

/**
*
* Generates the digest authentication header
*/
controller.getAuth = function (method, url, nonce) {
	ha1 = utils.MD5(username + ":os@xcerion.com:" + password);
	ha2 = utils.MD5(method + ":" + url);
	response = utils.MD5(ha1 + ":" + nonce + ":00000001:082c875dcb2ca740:auth:" + ha2);
	h = 'Digest username="' + username + '", realm="os@xcerion.com", nonce="' + nonce + '", uri="' + url + '", algorithm=MD5, response="' + response + '", qop=auth, nc=00000001, cnonce="082c875dcb2ca740"';
	return h;
}


/**
*
* Open a folder and its files
* @
*  folderId : the id of the folder to open
*  order: asc/desc 
*  type:  attribute to order with (default "title")
*  action: if "login" open the document folder
**/
controller.handleFolder = function (folderId, order, type, action) {
  //display the results
	function loadFilesSucceded(msg) {
		var endTime = Date.now();
		alert("Request File time: " + (endTime - initTime))
		alert("Load Files Succeded");
		$('#loading').sfLoading('hide');
		if (sf.scene.getVisible('LoginScene'))
			sf.scene.hide("LoginScene");
		if (!sf.scene.getVisible('DriveScene'))
			sf.scene.show('DriveScene');
		sf.scene.focus('DriveScene');
	}
  //open files when the folder reqeust is received
	function loadFoldersSucceded(msg) {
		var folderTime = Date.now();
		alert("Request Folder time: " + (folderTime - initTime));
		states.currentFolderId = folderId;
		alert("action: " + action);
		if (action != null && action == "login") {
			$(msg.documentElement).find('[name!=""]').each(function (i, fsFolder) {

				var sys = fsFolder.getAttribute("system");
				if (sys == "documents") {
					states.docFolderId = fsFolder.getAttribute("id");
					folderListIndex = new Array();
					folderListIndex.push(i); //
				}

			});

			controller.handleFolder(states.docFolderId, null, null);
		} else {
			if (type == null || type == undefined)
				type = "title";
			initTime = Date.now();
			model.loadFiles(folderId, 0, numberFilesRequest, order, type).done(loadFilesSucceded).fail(loadFailed); 
		}
	}
  
	function loadFailed(msg) {
		controller.logout("loginFailed", msg);
		$('#loadingDrive').sfLoading('hide');
		alert("Couldn't load folders or files" + msg);
	}
	var initTime = Date.now();
	if (order == null || order == undefined)
		order = true;
	model.loadFolders(folderId, "title", order, 0, false).done(loadFoldersSucceded).fail(loadFailed);
}

//Load remaining files of a folder (pagination)
controller.loadMore = function (folderId) {
	var loaded = false;
	
	function loadFilesSucceded(msg) {
		$('#loadingDrive').sfLoading('hide');
		loaded = true;
		loading = false;
		controller.addItemsToGrid();
	}
	function loadFailed(msg) {
		$('#loadingDrive').sfLoading('hide');
		alert("Couldn't load remaining files" + msg);
	}
	$('#loadingDrive').sfLoading('show');
	var loadPos = folderFiles.length;
	model.loadFiles(folderId, loadPos, numberFilesRequest, folderOrder, "title").done(loadFilesSucceded).fail(loadFailed);
	//Try to load them again if didnt work
	var interval = setInterval(function () {
			if (!loaded && states.currentFolderId == folderId) {
				model.loadFiles(folderId, loadPos, numberFilesRequest, folderOrder, "title").done(loadFilesSucceded).fail(loadFailed);
			} else {
				interval = window.clearInterval(interval);
			}
		}, 2000);

}

/**
* open sign up scene
*/
controller.goToSignUpScene = function () {
	sf.scene.hide("LoginScene");
	sf.scene.show('SignUpScene');
	sf.scene.focus('SignUpScene');
}

controller.preInit = function () {
	function loginSucceeded(msg) {
		alert("Login succeded");
		if(sf.scene.getVisible('SignUpScene')){
			sf.scene.hide("SignUpScene");
		}
		if(sf.scene.getVisible('LoginScene')){
			$(elementPassword).val("");
			$(elementPlain).val("");
			sf.scene.hide("LoginScene");
		}
		folderIdTree = new Array();
		imageFiles = new Array(); //image files returned from the folder query
		imageQueue = new Array();
		audioFiles = new Array(); //audio (mp3) files returned from the folder query
		folderRoute = new Array();
		folderRoute.push("Cloud Drive");
		folderRoute.push("Documents");
		favoritesRoute = new Array();
		favoritesRoute.push("Favorites");
		//	route ="CloudMe Drive";
		controller.handleFolder(states.homeFolderId, null, null, "login");
		maxTimesPlayed = 1;

	}

	function loginFailed(msg) {
		controller.logout("loginFailed", msg);
	}

	function a(user, pwd) {
		window.name = "";
		if (user && pwd) {
			storage.setUnsafeTempValue("isLoggedIn", "1");
			storage.setUnsafeTempValue("loginUsername", user);
			storage.setUnsafeTempValue("loginToken", pwd);
			return true;
		}
		return false;
	}
	alert("Preinit");

	storage.tempApply(a);

	PlayerPlugin = sf.core.plugin('PLAYER');

	controller.initLogin().done(loginSucceeded).fail(loginFailed);

};

controller.initLogin = function () {
	alert("initLogin");
	$('#loading').sfLoading('show');
	function success() {
		$('#loading').sfLoading('hide');
		//view.renderQuota(states.currentSize, states.quotaLimit);
		controller.reloadQuota;
		deferred.resolve();
	}

	function loginFailed(msg) {
		$('#loading').sfLoading('hide');
		alert("login failed: " + msg);
		SceneLoginScene.loginFailed(msg);
		deferred.reject(msg);
	}

	var deferred = $jq.Deferred();

	// Try to login
	controller.login().done(success).fail(loginFailed);

	return deferred;
};

controller.isLoggedIn = function () {

	if (storage.isLoggedIn() || storage.getUnsafeTempValue("user.username")) {
		return true;
	}
	return false;
}

controller.logout = function (msg, msg2) {
	alert("Logout: " + msg + " " + msg2);
	if (sf.scene.getVisible('DriveScene')) {
		sf.scene.hide('DriveScene');
	}
	if (sf.scene.getVisible('WebSharesScene')) {
		sf.scene.hide('WebSharesScene');
	}
	if (!sf.scene.getFocused('LoginScene')) {
		if (!sf.scene.getVisible('LoginScene')) {
			sf.scene.show('LoginScene');
		}
		sf.scene.focus('LoginScene');
	}

	if (window.cloudme && window.baxide && host) {
		alert("Send delete req");
		$.ajax({
			type : 'DELETE',
			async : false,
			cache : false,
			processData : false,
			url : host + '?access_token=' + encodeURIComponent('loggedOUT'),
			username : '*',
			password : '/'
		});
	}
	storage.setUnsafeTempValue("user.username", null);
	storage.setUnsafeTempValue("user.fullname", null);
	storage.setUnsafeTempValue("user.drive.currentSize", null);
	storage.setUnsafeTempValue("user.drive.quotaLimit", null);
	controller.setLoggedOut();

	//set vars to null to avoid leaking
	states = null;

	fold = null;
	folderFiles = null;
	folderTree = null;
	imageFiles = null;
	imageQueue = null;
	audoFiles = null;
	currentFocused = null;
	favorites = null;
	folderIdTree = null;
	controller.clearMusicInfo();
	$("#musicPause").attr("src", "images/control/media_pause.png");
	playingAudio = false;
	PlayerPlugin.Stop();
	PlayerPlugin = null;

};

controller.setLoggedOut = function () {
	alert("set logged out");
	storage.clear();
	storage.sessionClear();
};

controller.login = function () {
	alert("Controller login");
	function done(response, textStatus, XMLHttpRequest) {
		states.username = $(response).find('username').text();
		states.userId = $(response).find('userid').text();
		storage.setUnsafeTempValue("user.username", states.username);
		states.drives = $(response).find('drives')[0];
		states.currentFolderId = states.homeFolderId = $(response).find('home').text();
		states.libFolderId = $(response).find('library').text();
		states.mycloudme = $(response).find('mycloudme').text();

		function loginCloudmeDone() {
			controller.loadPlayList(states.libFolderId, "playqueue.m3u", "/Documents/Music/Playlists/", false);
			controller.getPlayqueuePos();
			//controller.createPortListener();
			deferred.resolve();
		}

		function loginCloudmeFail() {
			deferred.reject();
		}
		model.loginCloudme(response, textStatus, XMLHttpRequest).done(loginCloudmeDone).fail(loginCloudmeFail);
	}
	function fail(msg) {
		storage.clear();
		storage.sessionClear();
		deferred.reject(msg);
	}

	function tryLogin() {
		//if( states.cloudMeAPIStatus == 'ready' ) {

    model.login(loginUsername, loginToken).done(done).fail(fail);
		//} else if( states.cloudMeAPIStatus != 'failed' ) {
		//  setTimeout(tryLogin, 1000);
		//}
	}

	var deferred = $jq.Deferred();

	baxide.setHost(host);
	var loginUsername = null;
	var loginToken = null;

		loginUsername = storage.getValue("loginUsername");
		loginToken = storage.getValue("loginToken");
		if ((!loginUsername || !loginToken)) {
			loginUsername = storage.getUnsafeTempValue("loginUsername");
			loginToken = storage.getUnsafeTempValue("loginToken");
			loginUsername = loginUsername == "null" ? null : loginUsername;
			loginToken = loginToken == "null" ? null : loginToken;
		}
		if (loginUsername != null && loginToken != null) {
			if (states == null) {
				states = {};
			}
			states.username = loginUsername;
			tryLogin();
		} else {
			function a(user, pwd) {
				if (user && pwd) {
					loginUsername = user;
					loginToken = pwd;
					tryLogin();
					return true;
				}
				return false;
			}
			try {
				if (window.name && window.name != "" && window.name.indexOf(":") != -1) {
					storage.tempApply(a);
				} else {
					loginUsername = storage.getValue("loginUsername");
					loginToken = storage.getValue("loginToken");
					tryLogin();
				}
			} catch (e) {
				controller.setLoggedOut();
				//     window.location.href = window.locationProtocol + "//" + window.locationHostname;
				fail("Please login again");
			}
		}
		return deferred;
	};

  /**
  * Create a folder with folderName in parent folder id
  */
	controller.addNewFolder = function (folderName, id) {
		function success() {
			alert("Reload Folder");
			controller.handleFolder(states.currentFolderId, null, null, "login");

		}
		function fail() {}
		alert("Create folder");
		if (id == null)
			id = states.currentFolderId;
		model.createFolder(id, folderName, true).done(success).fail(fail);
	}

  /**
  *
  * Rename file or folder
  */
	controller.rename = function (newName, item) {
		function success() {
			alert("Reload Folder");
			controller.handleFolder(states.currentFolderId);
		}
		function failure() {
			alert("Rename failed ");
		}

		itemId = item.id;
		itemType = item.type;
		oldName = item.title;

		if (!newName || newName == oldName)
			return;

		if (itemType == "file" || itemType == "image") {
			model.renameFile(states.currentFolderId, itemId, newName, true).done(success).fail(failure);
		} else if (itemType == "folder") {
			model.renameFolder(states.currentFolderId, itemId, newName, true).done(success).fail(failure);
		}
	}

   /**
   *  Delete the items selected.
   *  fromSearch: specifies if deleting from a searcg query (need to look for parent folder id)
   */
	controller.deleteItem = function (itemsToDelete, fromSearch) {
		var numberToDelete = itemsToDelete.length;
		function success() {
			alert("Reload Folder");
			numberToDelete--;
			if (numberToDelete == 0)
				controller.handleFolder(states.currentFolderId);
		}
		function failure() {
			alert("Delete failed ");
			numberToDelete--;
			if (numberToDelete == 0)
				controller.handleFolder(states.currentFolderId);			
		}

		var totalToDelete = itemsToDelete.length;
		for (var i = 0; i < totalToDelete; i++) {
			var item = itemsToDelete.pop();
			var itemId = item.id;
			var itemType = item.type;
			var parentId;
			alert("item.id " + item.id);
			if (fromSearch) {
				parentId = item.parentId || item.dcFolder;
			} else {
				parentId = states.currentFolderId;
			}
			if (itemType == "file" || itemType == "image") {

				model.removeFile(parentId, itemId).done(success).fail(failure);
			} else if (itemType == "folder") {
				model.removeFolder(parentId, itemId).done(success).fail(failure);
			}
		}
	}

   /**
   *
   *  Move items to destination folder Id
   */
	controller.moveItems = function (itemsToMove, destFolderId) {
		alert("Move " + itemsToMove.length + " items  to " + destFolderId);
		var i = 0;
		function moveSuccess(p) {
			alert("Move item done " + itemsToMove.length);
			if (p == (numberToMove - 1)) {
				alert("Move to dest folder");
				//				controller.handleFolder(destFolderId,null,null);
				controller.handleFolder(states.currentFolderId, null, null);
			//	sf.scene.focus('DriveScene');
			}
		}
		function moveFailure(p) {
			alert("Error moving file or folder");
			if (p == (numberToMove - 1)) {
				controller.handleFolder(states.currentFolderId, null, null);
			}
		}

		var numberToMove = itemsToMove.length
			for (i = 0; i < numberToMove; i++) {
				item = itemsToMove.pop();
				itemType = item.type;
				itemId = item.id;
				alert("moving " + itemId);

				if (itemType == "file" || itemType == "image") {
					moveFile(states.currentFolderId, itemId, destFolderId, item.title, i);
				} else if (itemType == "folder") {

					moveFolder(itemId, destFolderId, item.title, "folder", i); ;
				}
				/*if (i == (numberToMove - 1)){
					controller.handleFolder(states.currentFolderId, null, null);
				} */
			}

		function moveFile(srcFolderId, srcDocumentId, dstFolderId, dstDocument, p) {
			model.moveDocument(srcFolderId, srcDocumentId, dstFolderId, dstDocument).done(function () {
				/*if (noUpdate)
					return;*/
				moveSuccess(p);
			}).fail(function () {
				moveFailure(p);
			});
		}

		function moveFolder(srcFolderId, dstFolderId, childFolder, type, p) {

			if (srcFolderId == destFolderId)
				return;

			alert("childFolder " + childFolder);
			var name = childFolder;
			var parentFolderId = states.currentFolderId;
			var childFolderId = srcFolderId;
			var destinationFolderId = dstFolderId;

			if (parentFolderId == destinationFolderId) {
				alert("Can't move " + itemType + " '" + name + "' to folder");
				return false;
			}

			if (childFolderId == destinationFolderId) {
				alert("Can't move " + itemType + " '" + name + "' to folder");
				return false;
			}

			model.moveFolder(parentFolderId, childFolderId, destinationFolderId, name).done(function () {
				//   model.path.set(childFolderId, name, destinationFolderId);
				moveSuccess(p);
			}).fail(function () {
				moveFailure(p);
			});
		}
	}

   /**
   *  Copy items selected to destFolderId
   **/
	controller.copyItems = function (itemsToCopy, destFolderId) {
		alert("copy " + itemsToCopy.length + " items  to " + destFolderId);

		function copyResult(i) {
			alert("Copy item done " + itemsToCopy.length);
			if (i == (numberToCopy - 1)) {
				//				controller.handleFolder(destFolderId,null,null);
				controller.handleFolder(states.currentFolderId, null, null);
				controller.diskUsage();
			}
		}

		var numberToCopy = itemsToCopy.length
			for (var i = 0; i < numberToCopy; i++) {
				item = itemsToCopy.pop();
				itemType = item.type;
				itemId = item.id;
				alert("copying " + itemId);

				if (itemType == "file" || itemType == "image") {
					copyFile(states.currentFolderId, itemId, destFolderId, item.title, false, i);
				} else if (itemType == "folder") {

					copyFolder(itemId, destFolderId, item.title, "folder", i);
				}
			}

		function copyFile(srcFolderId, srcDocumentId, dstFolderId, dstDocument, noUpdate, j) {
			model.copyDocument(srcFolderId, srcDocumentId, dstFolderId, dstDocument).done(function () {
				if (noUpdate)
					return;
				alert("deferred resolve");
				if(j >= 0) copyResult(j);
			}).fail(function () {
				//failure("Cant't copy '" + name + "' to folder");
				alert("Cant copy item");
				controller.unSelectAll();
			});
		}

		function copyFolder(srcFolderId, dstFolderId, childFolder, type, j) {

			if (srcFolderId == destFolderId)
				return;

			alert("childFolder " + childFolder);
			alert("srcFolderId " + srcFolderId);
			alert("dstFolderId " + dstFolderId);
			// create Mapp
			model.newFolder(dstFolderId, childFolder, "folder").done(function (res) {
				dstFolderId = $(res).find('newFolderId').text();
				// copy child Files
				model.queryFolder(srcFolderId, "true", "sv_SE").done(function (res) {
					$(res.documentElement).find(($.browser.webkit ? 'entry' : 'atom\\:entry')).each(function (i, atomEntry) {
						var childNodes = utils.getChildNodesByObj({
								"folder" : "",
								"document" : "",
								"title" : ""
							}, atomEntry);
						copyFile($(childNodes['folder']).text(), $(childNodes['document']).text(), dstFolderId, $(childNodes['title']).text(), true);
					});
					
				}).fail(function () {
					alert("/*** cant find any child files ***/");
					controller.unSelectAll();
				});

				// copy child Folders

				baxide.invokeGet("folders", srcFolderId, "/v1/folders/" + srcFolderId).done(function (doc) {
					$(doc.documentElement).find('[name!=""]').each(function (i, fsFolder) {

						var id = fsFolder.getAttribute("id");
						var name = fsFolder.getAttribute("name");
						alert("id " + id + "  name: " + name);
						if (name && name != "") {
							copyFolder(id, dstFolderId, name, "folder");
						}
					});
					alert("get folders done");
				}).fail(function () {
					/*** cant find any child mapps i guess ***/
					controller.unSelectAll();
				});
				controller.handleFolder(states.currentFolderId, null, null);
			}).fail(function () {
				alert("Can't copy '" + childFolder + "' to folder");
				controller.unSelectAll();
			});
		}
	}

  /**
  * Show folder scene 
  */
	controller.showFolderTree = function () {
		//create list box with all folders

		alert("Show folder tree");
		sf.scene.show('FolderScene');
		sf.scene.focus('FolderScene');

	}

  
  /**
  * Open a folder in folder scene
  */
	controller.expandFolder = function (folderId) {
		function done() {
			alert("Folder. expanded  size: " + folderTree[0].length);
			SceneFolderScene.loadList();
		}
		model.loadFolders(folderId, "title", true, true).done(done); // done _-> update list
	}

  /**
  * Selects/unselects the current focused item
  */
	controller.selectItem = function () {
		alert("Select item ");
		if (currentFocused < fold.length) {
			item = fold[currentFocused];
		} else {
			item = folderFiles[(currentFocused - fold.length)];
		}
		alert("item: " + item);
		var p = $jq.inArray(item.id, selectedItemsId);
		if ( p === -1) {
			selectedItemsId.push(item.id);
			selectedItems.push(item);
			//change font
			//		$("."+currentFocused+".cell").append("<div id='selectedItem'></div>");
			//		if(tvYear=="2011"){
			//$("." + currentFocused + ".cell .image").css('opacity', '0.1');
			if($("." + currentFocused + ".cell .thumbnail").length){
				$("." + currentFocused + ".cell").append("<div class='multipleThumbnail'></div>");
			}else{
				$("." + currentFocused + ".cell").append("<div class='multiple'></div>");
			};
			//		}else{
			//			$("."+currentFocused+".cell").css('background','#FAFF75');
			//		}
		} else {
			selectedItemsId.splice(p,1);
			selectedItems.splice(p,1);
			//change font
			//		if(tvYear=="2011"){
			//$("." + currentFocused + ".cell .image").css('opacity', '1');
			$("." + currentFocused + ".cell .multiple").remove();
			$("." + currentFocused + ".cell .multipleThumbnail").remove();
//			$("." + currentFocused + ".cell").css('background', 'transparent');
			//		}else{
			//			$("."+currentFocused+".cell").css('background','transparent');
			//		}
			//		$("."+currentFocused+".cell #selectedItem").remove();
		}
	}
	
	/**
	 * Unselects all
	 */

	controller.unSelectAll = function () {
		alert("Unselect all");
		for(var i=0; i< numberElements; i++){
			$("." + i + ".cell .multiple").remove();
			$("." + i + ".cell .multipleThumbnail").remove();
		}
	};
	
   /**
   *  Sets the breadcrumb of the current path
   */
	controller.setRoute = function (forward, tab) {
		alert("lastid: " + folderIdTree[(folderIdTree.length - 1)]);
		if (folderIdTree[(folderIdTree.length - 1)] == 0 && tab == "clouddrive") {
			alert("folderRoute " + folderRoute);
			if (folderRoute.length > 1 && folderRoute[(folderRoute.length - 1)].substring(0, 7) == 'Search:')
				folderRoute.pop();
			folderRoute.splice(folderIdTree.length - 1, 0, 'Search: "' + search.searchQuery + '"');
			alert("folderRoute " + folderRoute + " folderIdTree.length" + folderIdTree.length);
		} else {
			if (fold != null && fold != undefined && currentFocused != null && currentFocused != undefined) {
				alert(fold[currentFocused]);
				if (tab == "favorites") {
					if (forward) {
						//					route += " > "+fold[currentFocused].title;
						favoritesRoute.push(fold[currentFocused].title);
					} else {
						//					route = route.substring(0,route.lastIndexOf(" > "));
						//					favoritesRoute.pop();
					}
				}
				if (tab == "clouddrive") {
					if (forward) {
						//					route += " > "+fold[currentFocused].title;
						folderRoute.push(fold[currentFocused].title);
					} else {
						//					route = route.substring(0,route.lastIndexOf(" > "));
						folderRoute.pop();
					}
				}

			}
		}
	}

  /**
    Display current breadcrumb for a specific tab (cloud drive, favorites, websahres)
  */
	controller.drawRoute = function (tab) {
		//		$('#currentRoute').html(route);
		alert("tab: " + tab);
		$('#currentRoute').empty();
		if (tab == "favorites") {
			route = favoritesRoute;
		} else {
			while (states.currentFolderId == states.homeFolderId && folderRoute.length > 1 && folderRoute[(folderRoute.length - 1)].substring(0, 7) != 'Search:') {

				folderRoute.pop();
			}
			route = folderRoute;
		}
		for (i = 0; i < route.length; i++) {
			if (i == (route.length - 1)) {
				$('#currentRoute').append("<span style='color:grey;'>" + route[i] + "</span>");
			} else {
				$('#currentRoute').append("<span style='color:#68AEDD;'>" + route[i] + "</span>");
				$('#currentRoute').append(" > ");
			}

		}
		//alert("route: "+route);
	}

  /**
    Given a item id returns the parent folder id
  */
	controller.getParentFolderIdFromChildId = function (itemId) {
		var name = $(states.currentFolder.documentElement).find('[id="' + itemId + '"]').parent().attr('id');
		return name;
	}

	//time in ms
	//returns a string with hh:mm:ss format
	controller.getTime = function (time) {
		alert("time: " + time);
		var hour = Math.floor(time / 3600000);
		var min = Math.floor((time - hour * 3600000) / 60000);
		var sec = Math.floor((time - hour * 3600000 - min * 60000) / 1000);
		alert("Hour: " + hour);
		alert("Min: " + min);
		alert("Sec: " + sec);
		if (hour < 10)
			hour = "0" + hour;
		if (min < 10)
			min = "0" + min;
		if (sec < 10)
			sec = "0" + sec;
		return hour + ":" + min + ":" + sec;
	}

	//Display cloudme drive usage
	controller.diskUsage = function () {
		var usage = states.currentSize / states.quotaLimit;
		alert("usage " + usage);
		var width = 150 * usage;
		alert("width " + width);
		$('#userInfo').html("Using " + utils.formatBytes(states.currentSize) + " of " + utils.formatBytes(states.quotaLimit));
		$('#percentage').html("<div id='percentageUsed' style='background:#68AEDD; height:13px; width:" + width + "px; border:1px dotted grey'></div>");

	}

	// when enter is pressed in drive scene, check what to do with the file according to the mime type
  // 
	controller.handleFile = function () {
		alert("Is a File");
		var pos = currentFocused - fold.length;
/*		alert("file " + folderFiles[pos].title + " is a " + folderFiles[pos].type);
		alert("FILE href: " + folderFiles[pos].href);
		alert("FILE id: " + folderFiles[pos].id);
		alert("FILE mime: " + folderFiles[pos].mime);
		alert("FILE updated: " + folderFiles[pos].updated);
		alert("FILE size: " + folderFiles[pos].size);
		alert("FILE dcFolder: " + folderFiles[pos].dcFolder);
		alert("FILE dcDoc: " + folderFiles[pos].dcDoc);
		alert("FILE data: " + folderFiles[pos].data);
		alert("FILE index: " + folderFiles[pos].index); */

		switch (folderFiles[pos].mime) {
		case "video/quicktime":
		case "video/x-ms-wmv":
		case "video/ogg":
		case "video/avi":
		case "video/msvideo":
		case "video/x-msvideo":
		case "video/x-matroska":
		case "video/mpeg":
		case "video/3gpp":
		case "application/octet-stream":
		case "video/mp4": // Play video
			controller.stopAudio();
			//					sf.scene.hide('DriveScene');
			$("#SceneDriveScene").css('visibility', 'hidden');
			sf.scene.show('VideoScene');
			sf.scene.focus('VideoScene');

			break;

		case "audio/mpeg":
		case "audio/mp3":
		case "audio/mpeg3":
		case "audio/x-mpeg-3": // play audio
		case "audio/wav":
		case "audio/x-wav":
		case "audio/mp4a-latm":
		case "audio/mp4":
		case "audio/ogg":
		case "audio/x-ms-wma":
			$('#logout_popup').sfPopup({
				text : STR_PLAY_OR_ADD,
				buttons : [STR_PLAY_FOLDER, STR_ADD_TO_QUEUE, STR_ADD_FOLDER_TO_QUEUE],
				defaultFocus : 1,
				callback : function callback(selectedIndex) {
					if (selectedIndex == 0) {
						controller.playFolder(pos);
					}
					if (selectedIndex == 1) {
						controller.addToPlayQueue(pos);
					}
					if (selectedIndex == 2) {
						controller.addFolderToPlayQueue();
					}
				}
			});
			$('#logout_popup').sfPopup('show');

			break;

		case "image/jpg":
		case "image/jpeg":
		case "image/pjpeg": // open image
		case "image/png":
		case "image/gif":
		case "image/bmp":
			sf.scene.show('ImageScene');
			sf.scene.focus('ImageScene');
			break;

		case "audio/x-mpegurl":
		case "audio/mpegurl":
		case "audio/mpeg-url":
			controller.loadPlayList(folderFiles[pos].dcFolder, folderFiles[pos].title, model.getCurrentPath(), true);
			break;

		case "text/plain":
		case "text/html":
			sf.scene.show('TextScene');
			sf.scene.focus('TextScene', pos);
			break;

		default:
			//alert the file is not supported
			$('#logout_popup').sfPopup({
				text : STR_FILE_NOT_SUPPORTED_POPUP,
				buttons : [STR_OK],
				defaultFocus : 0,
				callback : function callback() {}
			});
			$('#logout_popup').sfPopup('show');
			break;
		}

	};

	// *******************************************************MUSIC***********************************************************************
	//handle the reproduction of music
	controller.playMusic = function (pos) {
		if (pos != undefined) {
			//var pos = currentFocused-fold.length;
			currentAudio = pos;
		}

		if (currentAudio == undefined || currentAudio == null || currentAudio <= 0) {
			currentAudio = 0;
		}
		baxide.playqueuePosition("PUT");
		0

		//generate a playQueue from the folder and plays music inside it
		if (playQueue.length > 0) {
			var l = playQueue[currentAudio].url || playQueue[currentAudio].href || playQueue[currentAudio].filePath;
			if (!l || l.indexOf("http") == -1) {
				//controller.getHrefFromPath(item.filePath).done(done);
			} else {
				if (l.charAt(l.length - 1) == "1") {
					var link = l + "/" + playQueue[currentAudio].title;
				} else {
					var link = l;
				}
			}
			link = baxide.generateUrl(link);
			alert("link: " + link);
			//PlayerPlugin = sf.core.plugin('PLAYER');
			PlayerPlugin.Stop();

			PlayerPlugin.InitPlayer(link);
			//	PlayerPlugin.SetPlayerProperty(5, "MP3", 0);
			PlayerPlugin.SetInitialBuffer(audioBufferSize); //400KB
			var totaltime;
			var loadingnext = false;

			connectionFailed = function () {
				alert("connection failed ");
			}
			authenticationFailed = function () {
				alert("auth  failed");
			}
			PlayerPlugin.OnStreamNotFound = function () {
				alert("stream not found  ");
			}
			PlayerPlugin.OnNetworkDisconnected = function () {
				alert("OnNetworkDisconnected  ");
			}
			PlayerPlugin.OnRenderError = function () {
				alert("OnRenderError  ");
			}
			streamNotFound = function () {
				alert("OnStreamNotFound  ");
			}
			PlayerPlugin.OnRenderingComplete = function () {
				alert("OnRenderingComplete ");
			}
			PlayerPlugin.OnBufferingStart = function () {
				alert("OnBufferingStart ");
			}
			onBuffering = function () {
				alert("OnBufferingComplete ");
				//	$("#musicPlayer #buffer").html("Buffer: 100%");
			}
			PlayerPlugin.OnBufferingProgress = function (percent) {
				alert("OnBufferingProgress  ");
				//	$("#musicPlayer #buffer").html("Buffer: "+percent+"%");
			}
			getInfo = function () {
				alert("stream ready ");
				totaltime = PlayerPlugin.GetDuration();
				loadingnext = false;
				if ($("#musicPause").attr("src") == "images/control/media_pause_red.png") {
					PlayerPlugin.Pause();
				}

				//	$("#musicPlayer #totalTime").html(controller.getTime(totaltime));

			}

       // method called every few ms
			setCurTime = function (time) {

				if (totaltime != null && time >= totaltime && !loadingnext) { // check if song ended
					//		$("#progressBar").css('width', '0px');
					loadingnext = true;
					controller.playNextSong(1);
				} else {
					if (!loadingnext) {
						$("#musicPlayer #time").html(controller.getTime(time));
						var barlength = $('#progressBarBackground').width();
						var progress = (time / totaltime * barlength) + 'px'; //
						$("#progressBar").css('width', progress);
					}
				}

			}
			PlayerPlugin.OnCurrentPlayTime = 'setCurTime';
			PlayerPlugin.OnStreamInfoReady = 'getInfo';
			PlayerPlugin.OnBufferingComplete = 'onBuffering';
			PlayerPlugin.OnStreamNotFound = 'streamNotFound';
			PlayerPlugin.OnConnectionFailed = 'connectionFailed';
			PlayerPlugin.OnConnectionFailed = 'authenticationFailed';
			playingAudio = true;
			PlayerPlugin.StartPlayback();

			controller.displayMusicInfo();
			$("#musicPlay").attr("src", "images/control/media_play_green.png");
			$("#musicPause").attr("src", "images/control/media_pause.png");
		}
	}

	controller.displayMusicInfo = function () {
		$("#musicPlayer #songTitle").empty();
		$("#musicPlayer #songArtist").empty();
		alert("playQueue[pos].artist: " + playQueue[currentAudio].artist);
		alert("playQueue[pos].song: " + playQueue[currentAudio].song);
		alert("playQueue[pos].title: " + playQueue[currentAudio].title);
		alert("playQueue[pos].artistSong: " + playQueue[currentAudio].artistSong);
		if (playQueue[currentAudio].artistSong) {

			$("#musicPlayer #songArtist").html(utils.capitaliseFirstLetter(playQueue[currentAudio].artistSong).split(" - ")[0]);
			if (playQueue[currentAudio].artistSong.indexOf(" - ") != -1)
				$("#musicPlayer #songTitle").html(utils.capitaliseFirstLetter(playQueue[currentAudio].artistSong).split(" - ")[1].italics());
		} else {
			if (playQueue[currentAudio].artist === undefined || playQueue[currentAudio].artist === null || playQueue[currentAudio].artist === "") {
				$("#musicPlayer #songTitle").html(playQueue[currentAudio].title);
			} else {
				$("#musicPlayer #songArtist").html(utils.capitaliseFirstLetter(playQueue[currentAudio].artist));
				$("#musicPlayer #songTitle").html(utils.capitaliseFirstLetter(playQueue[currentAudio].song).italics());
			}
		}
	}

	controller.clearMusicInfo = function () {
		$("#musicPlayer #songTitle").empty();
		$("#musicPlayer #songArtist").empty();
		$("#progressBar").width(0);
		$("#musicPlayer #time").html("00:00:00");
	}

	controller.stopAudio = function () {
		playingAudio = false;
		$("#musicPlay").attr("src", "images/control/media_play.png");
		$("#musicPause").attr("src", "images/control/media_pause.png");
		//	$("#songTitle").html("");
		$("#progressBar").width(0);
		$("#musicPlayer #time").html("00:00:00"); //time = 00:00:00
		PlayerPlugin.Stop();
	}

	//plays next song in the current playqueue.
  //  i = +1 or i =-1 (next song or previous song)
  // 
	controller.playNextSong = function (i) {
		PlayerPlugin.Stop();
		controller.clearMusicInfo();
		if (playQueue.length > 0) {
			if (randomPlay) { // RandomPlay not fully implemented
				currentAudio = Math.floor(Math.random() * playQueue.length); //
				if (playQueue[currentAudio].timesPlayed >= maxTimesPlayed) {
					currentAudio = jQuery.grep(playQueue, function (element, index) {
							if (element.timesPlayed < maxTimesPlayed)
								return index;
						});

				}
				if (currentAudio == undefined)
					currentAudio = Math.floor(Math.random() * playQueue.length);
			} else {
				if (currentAudio == null) {
					currentAudio = 0;
				} else {
					currentAudio += i;
					if (currentAudio == playQueue.length) {
						currentAudio = 0;
					}
					if (currentAudio < 0) {
						currentAudio = (playQueue.length - 1);
					}
				}
			}
			baxide.playqueuePosition("PUT"); // send the current playing position to the server.
			var l = playQueue[currentAudio].url || playQueue[currentAudio].href;
			if (l.charAt(l.length - 1) == "1") {
				var link = l + "/" + playQueue[currentAudio].title;
			} else {
				var link = l;
			}
			link = baxide.generateUrl(link);
			alert("link: " + link)
			playQueue[currentAudio].timesPlayed += 1;
			maxTimesPlayed = playQueue[currentAudio].timesPlayed;
			//			PlayerPlugin.Stop();
			if ($("#musicPause").attr("src") != "images/control/media_pause_red.png") {
				$("#musicPlay").attr("src", "images/control/media_play_green.png");
				$("#musicPause").attr("src", "images/control/media_pause.png");
				PlayerPlugin.Play(link);
			}

			controller.displayMusicInfo();
			ScenePlayQueueScene.prototype.drawSpeaker();
		}
	}
  
  // remove current playqueue and add all the music files from the current folder to the playqueue
	controller.playFolder = function (pos) {
		playQueue = new Array();
		playQueue = audioFiles.slice(0);
		var pos = jQuery.inArray(folderFiles[pos], audioFiles);
		controller.playMusic(pos);
		controller.syncPlayQueue();
	}

  // add a single song to the playqueue
	controller.addToPlayQueue = function (pos) {
		alert("node  " + folderFiles[pos].node);
		playQueue.push(folderFiles[pos]);
		playQueue[playQueue.length - 1].timesPlayed = 0;
		alert("node  " + folderFiles[pos].node);
		//controller.savePlayList();
		controller.syncPlayQueue();
	}

   // Add all the music files from the current folder to the playqueue
	controller.addFolderToPlayQueue = function () {
		playQueue = playQueue.concat(audioFiles);
		//controller.savePlayList();
		controller.syncPlayQueue();
	}
  
  //Gets the current position of the playqueue from the server
	controller.getPlayqueuePos = function () {
		baxide.playqueuePosition("GET");
	}
  
  //Loads a m3u playlist
	controller.loadPlayList = function (folderid, name, path, start, pos) {
		function done(res) {
			var m3uHeader = $(res).find("document").text().match(/^.{0,1}#EXTM3U.*/mg);
			if (!m3uHeader) {
				return;
			} else {
				playQueue = [];
				m3uHeader = m3uHeader[0];
			}
			var m3uItems = $(res).find("document").text().match(/^#(?!EXTM3U)[\s\S]*?^(?!#).*/mg);
			var files = new Array;
			m3uHeader = m3uHeader.replace(/#EXTM3U:\s*/g, '').split(";");
			if (m3uHeader.length == 3 && m3uHeader[0] != "") {
				playListLoaded = {
					folder : m3uHeader[1],
					name : m3uHeader[2],
					path : m3uHeader[0]
				};
				var item;
				$(m3uItems).each(function (index, value) {
					item = controller.getItemFromM3u(value);
					item.relativePath = item.filePath;
					playQueue.push(item);
					playQueue[index].timesPlayed = 0;
				});
			} else {
				$(m3uItems).each(function (index, value) {
					playQueue.push(controller.getItemFromM3u(value));
					playQueue[index].timesPlayed = 0;
				});
			}

			var type = (start ? "playlist" : null);
			if (folderid == states.libFolderId && name == "playqueue.m3u") {
				type = "playqueue";
				// playListLoaded = null;
			} else {
				playListLoaded = {
					folder : folderid,
					name : name,
					path : path
				};
			}

			if (folderid != states.libFolderId && name != "playqueue.m3u") {
				controller.syncPlayQueue(); //saveplaylist
				if (playingAudio)
					currentAudio = -1;
				else
					currentAudio = 0;
				baxide.playqueuePosition("PUT");
				controller.showPlaylistLoadedMessage();
			}
		}
		function fail() {
			alert("load playlist failed");
		}
		alert("load doc: " + folderid + "    " + name);
		model.loadDocument(folderid, name).done(done).fail(fail);
	}

  //save a playlist with name
	controller.savePlayList = function (name) {
		function done(res) {
			if (name != "playqueue.m3u" && folderId != states.libFolderId)
				playListLoaded = {
					folder : folderId,
					name : name,
					path : path
				};
			controller.syncPlayQueue();
			alert("playlist saved");
		}
		function fail() {
			alert("save playlist failed");
		}
		var entries = "";

		var path;

		if (playListLoaded != null) {
			path = playListLoaded.path;
		} else {
			path = "/Documents/Music/Playlists/";
		}
		$(playQueue).each(function (index, value) {

			//CHECK RELATIVE PATHS!
		if (!value.relativePath && value.filePath != undefined && value.filePath.indexOf("http") != 0 && value.filePath.indexOf(":\\") != 1)
			value.relativePath = controller.getRelativePathFromFixed(value.filePath.replace("\\", "/"), path);
			entries += controller.getM3uFromItem(value);
		});
		var folderId;

		if (name == undefined) {
			name = "playqueue.m3u";
			folderId = states.libFolderId;
			playListLoaded = null;
		} else {
			if (playListLoaded != null) {
				folderId = playListLoaded.folder;
				//name = name;
				path = playListLoaded.path;
			} else {
				if (name.indexOf(".m3u") == -1)
					name += ".m3u";
        path = "/Documents/Music/Playlists/";
				if (states.playlistId == undefined) {
					folderId = controller.searchPlaylistFolderAndSave(name, entries, path);
				} else {
					folderId = states.playlistId;
					playListLoaded = {
						folder : folderId,
						name : name,
						path : path
					};
				}

			}

		}

		if (folderId != undefined)
			model.savePlaylist(folderId, name, entries).done(done).fail(fail);
	}

  // Checks if the mime type is supported by the TV
	controller.audioSupported = function (mime) {
		switch (mime) {
		case "audio/mpeg":
		case "audio/mp3":
		case "audio/mpeg3":
		case "audio/x-mpeg-3":
			return true;
			break;
		default:
			return false;
		}

	}

  // Check playlist format
	controller.playlistSupported = function (mime) {
		var supported = {
			"audio/x-mpegurl" : "m3u",
			"audio/mpegurl" : "m3u",
			"audio/mpeg-url" : "m3u"
		};
		return supported[mime] != undefined;
	}

  //Syncs the current playqueue with the server. Makes it able to paly it from different devices
	controller.syncPlayQueue = function () {
		var entries = "";
		$(playQueue).each(function (index, value) {
			entries += controller.getM3uFromItem(value);
		});
		alert("entries: " + entries);
		model.savePlaylist(states.libFolderId, "playqueue.m3u", entries)
	}

	controller.showPlaylistLoadedMessage = function () {
		alert($("#messages"));
		$("#messages").html('PlayList Loaded');
		setTimeout(function () {
			$("#messages").html('')
		}, 2000);
	}

	controller.getM3uFromItem = function (item) {
		item.path = item.path || model.getCurrentPath(item.dcFolder);

		var path;
		if (item.externalHref) {
			path = item.externalHref;
		} else if (item.relativePath) {
			path = item.relativePath;
		} else if (item.filePath) {
			path = item.filePath;
		} else {
			path = item.path + item.title;
		}

		if (item.href) {
			var href = item.href;

			if (item.href.lastIndexOf("1") == (item.href.length - 1))
				href += "/" + item.title.replace(/ /g, "%20");
			if (item.href.lastIndexOf("https://") == -1)
				item.href = item.href.replace("http", "https");
		}
		var entry = (item.href ? "#EXTCME: " + href + "\n" : "") +
		(item.infLine ? item.infLine : "#EXTINF:," + item.artistSong) + "\n" +
		path + "\n";

		return entry;
	}

	controller.getItemFromM3u = function (m3uItem) {
		var file = {};
		var fileLine = m3uItem.match(/^(?!#).*/mg);
		if (fileLine) {
			file.filePath = fileLine[0].replace(/\\/g, "/");
		}
		var infLine = file.infLine = m3uItem.match(/^#EXTINF:.*/mg);
		if (infLine) {
			file.infLine = infLine[0];
			file.artistSong = infLine[0].substring(infLine[0].indexOf(",") + 1);

		} else {
			file.title = file.filePath.substring(file.filePath.lastIndexOf("/") + 1)
		}

		var cmeLine = m3uItem.match(/^#EXTCME:.*/mg);
		if (cmeLine)
			file.href = cmeLine[0].replace(/#EXTCME:\s*/g, '');
		var mimeTypes = {
			"mp3" : "audio/mpeg",
			"m4a" : "audio/mp4",
			"oga" : "audio/ogg",
			"ogg" : "audio/ogg",
			"wav" : "audio/wav"
		};
		file.mime = mimeTypes[file.filePath.substring(file.filePath.lastIndexOf(".") + 1)];
		return file;
	}

	controller.getHrefFromPath = function (path) {

		function folderIdLoaded(folderid) {
			function searchDone(res) {
				var matchedFile = $(res).filterNode("atom:entry").filter(function () {
						return $(this).filterNode("atom:title").text() == fileName;
					});
				var href;
				if (matchedFile.length != 0)
					href = matchedFile.filterNode("atom:link").attr("href").replace("http:", window.location.protocol);
				deferred.resolve(href);
			}
			var query = "title:" + fileName;
			model.listFiles([folderid], null, query).done(searchDone);
		}

		var fileName = path.substring(path.lastIndexOf("/") + 1);
		var fixedPath = controller.getFixedPathFromRelative(path, playListLoaded.path);
		var deferred = jq$.Deferred();
		model.path.loadFolderIdFromPath(fixedPath).done(folderIdLoaded);
		return deferred;
	}

	controller.getFixedPathFromRelative = function (relativePath, playlistPath) {
		var fixedPath,
		counter = 0;
		var path = playlistPath.charAt(playlistPath.length - 1) == "/" ? playlistPath.substring(0, playlistPath.length - 1) : playlistPath;
		while (relativePath.indexOf("../") == 0 && counter < 50) {
			relativePath = relativePath.substring(3);
			path = path.substring(0, path.lastIndexOf("/"));
			counter++;
		}
		fixedPath = path + "/" + relativePath;
		return fixedPath;
	}

	controller.getRelativePathFromFixed = function (filePath, playlistPath) {
		var relativePath;
		if (filePath.indexOf("../") != -1 || filePath.indexOf("/") == -1) {
			relativePath = filePath;
		} else {
			var fileName = filePath.substring(filePath.lastIndexOf("/") + 1);
			if (filePath == playlistPath + fileName) {
				relativePath = fileName;
			} else {
				var path = playlistPath.charAt(playlistPath.length - 1) == "/" ? playlistPath.substring(0, playlistPath.length - 1) : playlistPath;
				var upLevels = "",
				counter = 0;
				while (path.length != 0 && filePath.indexOf(path) == -1 && counter < 50) {
					path = path.substring(0, path.lastIndexOf("/"));

					upLevels += "../";
					counter++;
				}
				relativePath = upLevels + filePath.substring(path.length + 1);
			}
		}
		return relativePath;
	}
  
  	//Conver to item DEPRECATED*****
	controller.convertFeedToItems = function (feed) {
		var files = new Array;
		var name = "";
		var folder = "";
		var target,
		href,
		rel;
		alert("CONVERT FEED TO ITEMS " + tvYear);
		if (tvYear == "2011") {
			alert("FEED");
			alert("1 " + $(feed).find("[nodeName='atom:feed']").attr("folder"));
			if ($(feed).find("[nodeName='atom:feed']").attr("folder")) { // If Play Queue.xml load playlist data.
				folder = $(feed).find("[nodeName='atom:feed']").attr("folder");
				alert("2 " + $(feed).find("[nodeName='atom:feed']").attr("folder"));

				name = $(feed).find("[nodeName='atom:feed']").attr("name");
				alert("3 " + $(feed).find("[nodeName='atom:feed']").attr("name"));

			}
			alert("4 " + $(feed).find("[nodeName='atom:entry']"))

			$(feed).find("[nodeName='atom:entry']").each(function (index, value) {
				files[index] = {};
				if ($(value).children("[nodeName='dc:document']")[0]) {
					if ($(value).children("[nodeName='atom:link'][rel='enclosure']").length != 0) {
						rel = "enclosure";
					} else {
						rel = "alternate";
					}
					files[index].title = $(value).children("[nodeName='atom:title']").text();
					files[index].id = $(value).children("[nodeName='dc:document']").text();
					files[index].mime = $(value).children("[nodeName='atom:link'][rel='" + rel + "']").attr("type");
					files[index].href = $(value).children("[nodeName='atom:link'][rel='" + rel + "']").attr("href").replace("http:", window.location.protocol);
					files[index].updated = utils.getStorageDatetime($(value).children("[nodeName='atom:updated']").text());
					files[index].size = utils.formatBytes($(value).children("[nodeName='atom:link']").attr("length"));
					files[index].dcFolder = $(value).children("[nodeName='dc:folder']").text();
					if (controller.audioSupported(files[index].mime)) {
						files[index].artist = $(value).children("[nodeName='dc:artist']").last().text();
						files[index].song = $(value).children("[nodeName='dc:name']").last().text();
						files[index].node = value;
					}
					files[index].type = "file";
				}
			});
		} else {
			if ($(feed).find("feed").attr("folder")) { // If Play Queue.xml load playlist data.
				folder = $(feed).attr("folder");
				name = $(feed).attr("name");
				alert("folder: " + folder + "    name: " + name);
				//     oThis.playlistLoaded = {folder:folder, name:name};
			}

			$(feed).find("entry").each(function (index, value) {
				files[index] = {};
				if ($(value).find("document")[0]) {
					rel = "alternate";
					$(value).find("link").each(function () {
						alert("atr   " + $(this).attr("rel"));
						if ($(this).attr("rel") == 'enclosure') {
							rel = "enclosure";
							files[index].mime = $(this).attr("type");
							files[index].href = $(this).attr("href").replace("http:", window.location.protocol);
						}
					});
					alert("rel: " + rel);
					if (rel == 'alternate') {
						files[index].mime = $(value).find("link", "rel", rel).attr("type");
						files[index].href = $(value).find("link", "rel", rel).attr("href").replace("http:", window.location.protocol);
					}
					files[index].title = $(value).find("title").text();
					files[index].id = $(value).find("document").text();
					files[index].updated = utils.getStorageDatetime($(value).find("updated").text());
					files[index].size = utils.formatBytes($(value).find("link").attr("length"));
					files[index].dcFolder = $(value).find("folder").text();
					if (controller.audioSupported(files[index].mime)) {
						files[index].artist = $(value).find("artist").last().text();
						files[index].song = $(value).find("name").last().text();
						files[index].node = value;
					}
					files[index].type = "file";
				}
			});
		}
		if (folder != "" && name != "" && folder != undefined && name != undefined) {
			playListLoaded = {
				folder : folder,
				name : name
			};
			alert("Name: " + name);
			alert("folder: " + folder);
		} else {
			playListLoaded = null;
		}
		return files;
	}

  //Creates the playlist folder under /Documents/Music/Playlists if not created
  // Save the playlist in that path
	controller.createPlaylistFolderAndSave = function (name, entries) {
		function savePlaylistDone(res) {
			playListLoaded = {
				folder : states.playlistId,
				name : name
			};

			alert("playlist saved");
		}
		function savePlaylistFail() {
			alert("save playlist failed");
		}
		function donePlaylist(res) {

			states.playlistId = res;
			if (name != undefined && entries != undefined) {
				model.savePlaylist(states.playlistId, name, entries).done(savePlaylistDone).fail(savePlaylistFail);

			}
		}
		function failPlaylist(res) {
			states.playlistId = (model.searchFolder("Playlists", states.docFolderId)).id;
			if (name != undefined && entries != undefined) {
				model.savePlaylist(states.playlistId, name, entries).done(savePlaylistDone).fail(savePlaylistFail);
			}

		}
		function searchMusicDone(res) {

			model.createFolder(res, "Playlists", true).done(donePlaylist).fail(failPlaylist);

		}
		function searchMusicfail(res) {}
		function done(res) {
			alert("music created  " + res);
			model.createFolder(res, "Playlists", true).done(donePlaylist).fail(failPlaylist);

		}
		function fail(res) {
			model.getFolderIdFromName("Music", states.docFolderId).done(searchMusicDone).fail(searchMusicfail);
		}
		alert("createplaylistfolder");
		model.createFolder(states.docFolderId, "Music", true).done(done).fail(fail);
	}

	//Search for the playlist folder. If found, save the playlist id in states.playListId. If not found, calls createPlaylistFolderAndSave
	controller.searchPlaylistFolderAndSave = function (name, entries, path) {
		function savePlaylistDone(res) {
			playListLoaded = {
				folder : states.playlistId,
				name : name,
				path : path
			};
			controller.syncPlayQueue();

			alert("playlist saved");
		}
		function savePlaylistFail() {
			alert("save playlist failed");
		}
		function donePlaylist(res) {

			states.playlistId = res;
			if (name != undefined && entries != undefined) {
				model.savePlaylist(states.playlistId, name, entries).done(savePlaylistDone).fail(savePlaylistFail);

			}
		}
		function failPlaylist(res) {
			controller.createPlaylistFolderAndSave(name, entries);

		}
		function done(res) {
			model.getFolderIdFromName("Playlists", res).done(donePlaylist).fail(failPlaylist);
		}
		function fail() {
			controller.createPlaylistFolderAndSave(name, entries);
		}
		model.getFolderIdFromName("Music", states.docFolderId).done(done).fail(fail);
	}

	//go to /Documents/Music/Playlist. Restore folderROute and Id tree. change tab and menu if needed. hide playqueue scene
	controller.goToPlaylists = function () {
		folderIdTree = new Array(); // tree of folder ids for the route
		if (folderListIndex.length == 0) {
			folderListIndex.push(0);
		} else {
			while (folderListIndex.length > 1)
				folderListIndex.pop();
		}
		folderIdTree.push(states.homeFolderId);
		folderIdTree.push(states.docFolderId);
		folderRoute = new Array();
		folderRoute.push("Cloud Drive");
		folderRoute.push("Documents");
		function playlistFolderDone(res, pos) {
			folderIdTree.push(res);
			folderListIndex.push(pos);
			folderRoute.push("Playlists");
			sf.scene.hide('PlayQueueScene', "clouddriveplaylists");
		}
		function playlistFolderFail() {}
		function musicFolderDone(res, pos) {
			folderIdTree.push(res);
			folderListIndex.push(pos);
			folderRoute.push("Music");
			model.getFolderIdFromName("Playlists", res).done(playlistFolderDone).fail(playlistFolderFail);
		}
		function musicFolderFail() {}
		model.getFolderIdFromName("Music", states.docFolderId).done(musicFolderDone).fail(musicFolderFail);

	}

	controller.serialize = function (value) {
		var entries = "";
		//alert("valueee: "+value.title+"   type: "+typeof (value));
		//alert("valueee.node: "+playQueue[index].node);
		alert("valueee.node.att: " + value.hasAttributes());
		if (value.hasAttributes()) {
			entries += '<' + value.nodeName + ' xmlns:atom="http://www.w3.org/2005/Atom" xmlns:dc="http://xcerion.com/directory.xsd">';
		} else {
			entries += '<' + value.nodeName + ' xmlns:atom="http://www.w3.org/2005/Atom">';
		}

		var child = value.firstChild;
		alert("first node: " + child.nodeName);
		while (child != null && child.nodeName != "atom:entry") {
			//child.
			if (child.hasAttributes() && child.nodeName == "atom:link") {
				var type = $(child).attr("type");
				var rel = $(child).attr("rel");
				var href = $(child).attr("href");
				var length = $(child).attr("length");
				alert("child length " + length);
				if (length == undefined) {
					entries += '<' + child.nodeName + ' rel="' + rel + '" type="' + type + '" href="' + href + '"/>';
				} else {
					entries += '<' + child.nodeName + ' rel="' + rel + '" type="' + type + '" href="' + href + '" length="' + length + '"/>';
				}
			} else {
				alert("attributes " + child.hasAttributes());
				if (child.nodeName.indexOf("dc") != -1) {
					entries += '<' + child.nodeName + ' xmlns:dc="http://xcerion.com/directory.xsd">';
				} else {
					entries += "<" + child.nodeName + ">";
				}
				if (child.textContent.indexOf("&") != -1) {
					entries += child.textContent.replace("&", "&amp;");
				} else {
					entries += child.textContent;
				}
				entries += "</" + child.nodeName + ">";
			}

			/*	alert("child: "+child.nodeName);
			alert("child node: "+child.nodeValue);
			alert("child node: "+child.nodeType);
			alert("child node: "+child.textContent);
			alert("child node: "+child.localName);*/
			child = child.nextSibling;

			//	alert("child "+child);
		}
		alert("entries: " + entries);
		entries += "</atom:entry>";
		alert("entries: " + entries);
		// entries += $(value.node).serialize();
		return entries;
	}
	//********************************END MUSIC*********************************************

  //Add items to the item grid
	controller.addItemsToGrid = function () {
		SceneDriveScene.prototype.addItems();
	}

	controller.videoError = function (msg) {
		sf.scene.hide('VideoScene');
		if (!sf.scene.getVisible('DriveScene')) {
			sf.scene.show('DriveScene');
		}
		sf.scene.focus('DriveScene');
		$('#SceneDriveScene #error_popup').sfPopup({
			text : msg,
			buttons : ["OK"],
			defaultFocus : 0,
			callback : function logoutCallback(selectedIndex) {}
		});
		$('#SceneDriveScene  #error_popup').sfPopup('show');

	}

	controller.exit = function () {
		//Mandatory by samsung to quit app if its the first scene to show -> if it is already signed
		if (storage.getValue("keepLoggedIn") == 1 || storage.getValue("keepLoggedIn") == "yes") {
			sf.core.exit(false);
		}
	}

	//*******************************FAVORITES***************************************

	controller.loadFavorites = function (order, type) {

		function loadFoldersSucceded(msg) {
			var folderTime = Date.now();
			folderFiles = new Array();
			alert("Request Folder time: " + (folderTime - initTime));
			if (type == null || type == undefined)
				type = "title";
			//draw favorites
			if (!sf.scene.getVisible('DriveScene'))
				sf.scene.show('DriveScene');
			sf.scene.focus('DriveScene');

		}

		function loadFailed(msg) {
			//controller.logout("loginFailed", msg);
			$('#loadingDrive').sfLoading('hide');
			alert("Couldn't load favorites" + msg);
		}
		var initTime = Date.now();
		if (order == null || order == undefined)
			order = true;
		model.loadFavorites("title", order, 0, false).done(loadFoldersSucceded).fail(loadFailed);
	}

	//Opens a favorite.If open is set to false, it just fetch the data from the favorite but doesn't open it
	// @folders: array with the folder name's route inside the favorite.
	controller.openFavorite = function (favId, open, folders, order, type) {
		function loadFoldersSucceded(msg, summary) {
			alert("msg " + msg);
			var folderTime = Date.now();
			alert("Request Folder time: " + (folderTime - initTime));
			//		states.currentFolderId = folderId;
			if (type == null || type == undefined)
				type = "title";
			initTime = Date.now();
			//		model.loadFiles(folderId, 0, numberFilesRequest, order, type).done(loadFilesSucceded).fail(loadFailed);
			if (open) {
				//draw folders
				if (!sf.scene.getVisible('DriveScene'))
					sf.scene.show('DriveScene');
				sf.scene.focus('DriveScene');
			} else {
				SceneDriveScene.prototype.fillMenu(summary);
			}
		}

		function loadFailed(msg) {
			//		controller.logout("loginFailed", msg);
			$('#loadingDrive').sfLoading('hide');
			alert("Couldn't load favorites" + msg);
		}
		var initTime = Date.now();
		if (order == null || order == undefined)
			order = true;
		//	if(item.target != null){
		//		model.loadFavorite(item.target[0], item.target[1], open, folders, "title", order,0 , false).done(loadFoldersSucceded).fail(loadFailed);
		//	}else{

		model.loadFavorite(favId, model.getFavoritePath(), open, folders, "title", order, 0, false).done(loadFoldersSucceded).fail(loadFailed);
		//	}
	}

	controller.deleteFavorite = function (item) {

		function done(response) {
			alert("deleted");
			controller.loadFavorites();
			deferred.resolve(response);

		}

		function fail(response) {
			deferred.reject(response);
		}

		var deferred = $jq.Deferred();
		model.deleteFavorite(item.id).done(done).fail(fail);
		return deferred;
	}

	controller.addFavorite = function (username, webshare) {
		function done(response) {
			deferred.resolve(response);
			controller.loadFavorites();
		}

		function fail(response) {
			alert("resp: " + response.httpErrorCode);
			switch (response.httpErrorCode) {
			case 409:
				SceneDriveScene.prototype.showErrorPopup(STR_WEBSHARE_ALREADY_ADDED);
				break;
			case 404:
				SceneDriveScene.prototype.showErrorPopup(STR_WEBSHARE_NOT_FOUND);
				break;
			case 403:
				SceneDriveScene.showFavoritePwdPopup(userName, webShare);
				break;
			default:
				break;
			}
			deferred.reject(response);
		}
		var error = 0;
		var userName = username || $("#favUsernameInput").val();
		var webShare = webshare || $("#favWebshareInput").val();

		if (userName == "") {
			$("#favUsernameInput").css("background-color", "#FED4D4");
			error = error + 1;
		}
		if (webShare == "") {
			$("#favWebshareInput").css("background-color", "#FED4D4");
			error = error + 1;
		}
		alert("error: " + error);
		if (error == 0) {
			var deferred = $jq.Deferred();
			model.addFavorite(userName, webShare, $("#favPasswordInput").val()).done(done).fail(fail);
			return deferred;
		} else if (error == 2) {
			//   var webshareHref = "http://my.cloudme.com/username/webshare";
			//   $("#addFavUrl").text(webshareHref);
			//  $("#addFavUrl").attr("href", webshareHref);
			//  view.showAddFavError("Required fields.", $("#addFavUserInput"));

		}

	}

	//******************************************************WEBSHARES*****************************************************
	controller.getWebShares = function () {
		function loadWebSharesSucceded(msg) {
			alert("websahres loaded ");

			sf.scene.show('WebSharesScene');
			sf.scene.focus('WebSharesScene');
		}

		function loadWebSharesFailed(msg) {
			alert("Couldn't load the webshares");

		}
		model.getWebShares(states.userId, false, 0, 100).done(loadWebSharesSucceded).fail(loadWebSharesFailed);
	}

	controller.saveWebShare = function (webShareId) {
		function done(mgs) {
			SceneWebSharesScene.prototype.saveResult(true);
		}

		function fail(msg) {
			SceneWebSharesScene.prototype.saveResult(false);
		}

		var name = document.getElementById("webShareNameInput").value;
		var pwd = document.getElementById("webSharePasswordInput").value;
		var descr = document.getElementById("webShareDescriptionInput").value;
		var priv = $('#private_checkbox').sfCheckBox('getChecked');
		model.saveWebShare(webShareId, name, pwd, priv, descr).done(done).fail(fail);
	}

	controller.deleteWebShare = function (webShareId) {
		function done(mgs) {
			controller.getWebShares();
		}

		function fail(msg) {
		}

		model.deleteWebShare(webShareId).done(done).fail(fail);

	}

	controller.createWebShare = function (item) {
		function done(mgs) {
			alert("websahre created");
			controller.getWebShares();
			currentTab = "webshares";
			SceneDriveScene.prototype.drawMenu(currentTab); //change menu
			SceneDriveScene.prototype.selectTab(currentTab);
		}

		function fail(msg) {
			alert("websahre creation failed");
		}
		alert("item.folder " + item.dcFolder);
		model.createWebShare(item.id, item.title, item.dcFolder).done(done).fail(fail);

	}

	//*********************************************************************SEARCH******************************************************************

  //Gets all folder IDs for the current user
	controller.getFolderId = function () {
		function done(response) {
		}
		function fail(response) {
		}
		model.getAllFolderId().done(done).fail(fail);
	}

	controller.search = function (searchQuery) {
		function done(response) {

			if (folderIdTree[(folderIdTree.length - 1)] != 0) {
				folderIdTree.push(0); //add a fake folder ID to know we are searching
				folderListIndex.push(currentFocused);
			}
			controller.setRoute(null, "clouddrive"); // add the search query to the route.
			alert("search success");
			currentFocused = 0;
			if (!sf.scene.getVisible('DriveScene'))
				sf.scene.show('DriveScene');
			sf.scene.focus('DriveScene');

		}
		function fail(response) {
			//		deferred.reject(response);
		}
		search.searchQuery = searchQuery;
		var pos = $.inArray(0, folderIdTree);
		alert("search pos: " + pos);
		if (pos != -1)
			folderIdTree.splice(pos, 1);
		model.getSearchResult(searchQuery + "*").done(done).fail(fail);
	}
	// FIND ROUTE FROM FOLDER ID
	controller.findRoute = function (folderId, folderName) {
		var fId = folderId;
		var item;
		var resultRoute = new Array();
		while (fId != null) {
			alert("fId " + fId + "  folderName " + folderName);
			item = $.grep(foldersId, function (obj) {
					return fId == obj.id;
				});
			alert("item: " + item);
			item = item[0];
			fId = item.parentId;
			folderName = item.name;
			if (fId != null) {
				resultRoute.push(folderName);
			} else {
				resultRoute.push("Cloud Drive");
			}
		}
		resultRoute = resultRoute.reverse(); //turn aroun route
		alert("resultRoute: " + resultRoute);
		folderRoute = new Array();
		folderRoute = resultRoute.slice(0);
		return resultRoute;
	}
  // FIND PATH FROM FILE ID
	controller.getPathFromFileId = function (itemParentId) {
		var routeArray = controller.findRoute(itemParentId, null);
		var path = "";
		for (i = 1; i < routeArray.length; i++) {
			path += "/" + routeArray[i];
		}
		path += "/";
		return path;
	}
  

  //***************** TEXT FILE***************
	//Read txt file
	controller.getTxtFile = function (url) {
		var fileUrl = baxide.generateUrl(url);
		jQuery.get(fileUrl, function (data) {
			//process text file line by line
			//alert("data::::: "+ data.replace('\n','<br>'));
			data = data.replace(/\n/g, '<br>');
			$('#openTextFile').html(data);
			SceneTextScene.prototype.showScroll();
		});
	}

  //********************PORT LISTENER**********
  // NOT FULLY IMPLEMENTED
  // In the future it will be able to control the tv with the cloudme phone app
	//CREATE PORTS
	controller.createPortListener = function (userId, folderId, documentName) {
		function done(url) {
			alert("url: " + url);
			$.get(url, function (data) {
				alert("port listener data: " + data)
			});

		}
		function fail() {}
		model.createPortListener(states.userId).done(done).fail(fail);
	};
