
var baxide = {
	xmlHttp : null,
	xmlHttp2 : null
};
var nonce = null;
var session = null;
var timeoutVal = 30000;

baxide.invoke = baxide.invokeGet = function () {
	var deferred = $jq.Deferred();
	var errorObject = {};
	errorObject.isLocalError = true;
	errorObject["description"] = "Missing username and password";
	deferred.reject(errorObject);
	return deferred;
}

baxide.login = function (username, password, clientString) {
	baxide.setUserAndPass(username, password);
	return baxide.invoke("login", {
		"client" : clientString
	});

}

baxide.setUserAndPass = function (username, password) {
	//alert("baxide.setUserandpass: "+username+"  "+password);
	/**
	 * Invoke the baxide servers. The POST message is constructed using the
	 * provided method name and params.
	 *
	 * @param String method
	 * Will be the SOAP-action and name of the root node (inside the SOAP envelope)
	 *
	 * @paylod String (optional)
	 * Will use supplied payload instead of building one up with params
	 *
	 * @return Deferred
	 * A jQuery Deferred object
	 */
	baxide.invoke = function (method, params, url, payload, id) {

		if (tvYear == "2011") {
			return baxide.invokeMaple(method, params, url, payload, id);
		}

		var url = "/v1/";
		var timeSent;
		var deferred = $jq.Deferred();
		//$.support.cors = true;
		//jQuery.support.cors = true;
		$jq.ajax({
			type : 'POST',
			async : true,
			cache : false,
			contentType : 'text/xml; charset=utf-8',
			dataType : 'xml',
			processData : false,
			url : baxide.host + (url ? url : ""),
			username : username,
			password : password,
			timeout : timeoutVal,
			data : baxide.soap(payload ? payload : baxide.createPostBody(method, params, id)),
			beforeSend : function (xhr) {
				xhr.setRequestHeader("Content-Type", 'text/xml; charset=utf-8'); //new
				xhr.setRequestHeader('SOAPAction', method);
				xhr.setRequestHeader('X-Requested-with', 'this.XMLHttpRequest');
				xhr.setRequestHeader('Pragma', 'no-cache');
				xhr.setRequestHeader('Cache-Control', 'no-cache');
				now = new Date();
				timeSent = now.getTime();
			},
			success : function (data, textStatus, jqXHR) {
				var successTime = new Date().getTime();

				deferred.resolve(baxide.unSOAP(data), textStatus, jqXHR);
				deferred = null;
				jqXHR = null;
				//view.addDebugSuccess("Success " + method + " " + (successTime.getTime() - timeSent));
			},
			error : function (jqXHR, textStatus, errorThrown) {
				var errorObject = {};
				errorObject["httpErrorCode"] = jqXHR.status;
				errorObject["httpErrorText"] = errorThrown;
				errorObject.isHTTPError = true;
				if (jqXHR.responseXML) {
					$(jqXHR.responseXML).find("error").each(function () {
						errorObject["baxideNumber"] = $(this).attr("number");
						errorObject["baxideCode"] = $(this).attr("code");
						errorObject["baxideDescription"] = $(this).attr("description");
						errorObject["baxideText"] = $(this).text();
						errorObject.isBaxideError = true;
					});
				} else if (jqXHR.responseText) {
					errorObject["baxideText"] = jqXHR.responseText;
				}
				deferred.reject(errorObject);
				jqXHR = null;
			}
		});
		return deferred;
	}

	// INVOKE 2011
	baxide.invokeMaple = function (method, params, url, payload, id) {
		var url = "/v1/";
		var type = "POST";
		if (nonce == null) {
			baxide.setNonce(null);
		}

		var received = false;
		alert("Invoke Maple ");
		var deferred = $jq.Deferred();

		var h = baxide.getAuth(type, url, 'digest');
		var data = baxide.soap(payload ? payload : baxide.createPostBody(method, params, id));
		if (this.xmlHttp != null) {
			this.xmlHttp.destroy();
		}
		this.xmlHttp = new XMLHttpRequest();
		this.xmlHttp.open('POST', host + '/v1/', true);

		this.xmlHttp.setRequestHeader("Content-Type", 'text/xml; charset=utf-8');
		this.xmlHttp.setRequestHeader('Accept', 'application/xml, text/xml, */*');
		this.xmlHttp.setRequestHeader('Accept-Encoding', 'gzip, deflate');
		this.xmlHttp.setRequestHeader('SOAPAction', method);
		this.xmlHttp.setRequestHeader('X-Requested-with', 'XMLHttpRequest');
		this.xmlHttp.setRequestHeader('Pragma', 'no-cache');
		this.xmlHttp.setRequestHeader('Cache-Control', 'no-cache');
		this.xmlHttp.setRequestHeader('dataType', 'xml');
		this.xmlHttp.setRequestHeader('processData', false);
		this.xmlHttp.setRequestHeader('async', true);
		this.xmlHttp.setRequestHeader('cache', false);
		this.xmlHttp.setRequestHeader('url', url);
		this.xmlHttp.setRequestHeader('Authorization', h);
		this.xmlHttp.onreadystatechange = function responseMessage() {

			if (baxide.xmlHttp.readyState == 4) {
				received = true;
				if (baxide.xmlHttp.status == 200) {

					var textStatus = baxide.xmlHttp.getResponseHeader('statusText');
					var unsoaped = baxide.unSOAP(baxide.xmlHttp.responseText);
					deferred.resolve(unsoaped, textStatus, baxide.xmlHttp);

					//		baxide.xmlHttp.destroy();
					//		baxide.xmlHttp = null;
					//	return deferred;
				} else {
					if (baxide.xmlHttp.status == 401) {
						baxide.setNonce(baxide.xmlHttp.getResponseHeader('WWW-Authenticate'));
						if (baxide.xmlHttp != null) {
							baxide.xmlHttp.destroy();
						}
						h = baxide.getAuth(type, url, 'digest');
						baxide.xmlHttp = new XMLHttpRequest();
						baxide.xmlHttp.open('POST', host + '/v1/', true);
						baxide.xmlHttp.setRequestHeader('Accept', 'application/xml, text/xml, */*');
						baxide.xmlHttp.setRequestHeader('Accept-Encoding', 'gzip, deflate');
						baxide.xmlHttp.setRequestHeader('Accept-Language', 'en');
						baxide.xmlHttp.setRequestHeader("Content-Type", 'text/xml; charset=utf-8');
						baxide.xmlHttp.setRequestHeader('SOAPAction', method);
						baxide.xmlHttp.setRequestHeader('X-Requested-with', 'XMLHttpRequest');
						baxide.xmlHttp.setRequestHeader('Pragma', 'no-cache');
						baxide.xmlHttp.setRequestHeader('Cache-Control', 'no-cache');
						baxide.xmlHttp.setRequestHeader('dataType', 'xml');
						baxide.xmlHttp.setRequestHeader('processData', false);
						baxide.xmlHttp.setRequestHeader('async', true);
						baxide.xmlHttp.setRequestHeader('cache', false);
						baxide.xmlHttp.setRequestHeader('url', url);
						baxide.xmlHttp.setRequestHeader('Authorization', h);

						baxide.xmlHttp.onreadystatechange = function response2Message() {
							if (baxide.xmlHttp.readyState >= 4) {
								received = true;
							} else {
								received = false;
							}
							if (baxide.xmlHttp.readyState == 4) {
								if (baxide.xmlHttp.status == 200) {
									//received = true;

									var textStatus = baxide.xmlHttp.getResponseHeader('statusText');
									deferred.resolve(baxide.unSOAP(baxide.xmlHttp.responseText), textStatus, baxide.xmlHttp);
									//baxide.xmlHttp.destroy();
									//baxide.xmlHttp = null;
									return deferred;
								} else {
									//received = false;
									alert("Error 2: " + baxide.xmlHttp.status);
									deferred.reject();
									return deferred;
								}
							}
						}
						var t = setTimeout(function () {
								if (received == false) {
									alert("Timed out!!!");
									var errorObject = {};
									errorObject["httpErrorText"] = "Timeout. Couldn't contact the server. Please, try again later.";
									errorObject.isHTTPError = true;
									baxide.xmlHttp.abort();
									timeoutVal = timeoutVal * 2;
									deferred.reject(errorObject);

									return deferred;
								}
							}, timeoutVal);
						received = false;
						baxide.xmlHttp.send(data);

					} else { //error diferent than 401,
						var errorObject = {};
						errorObject["httpErrorCode"] = baxide.xmlHttp.status;
						errorObject["httpErrorText"] = baxide.xmlHttp.statusText;
						errorObject.isHTTPError = true;
						if (baxide.xmlHttp.responseXML) {
							$(baxide.xmlHttp.responseXML).find("error").each(function () {
								errorObject["baxideNumber"] = $(this).attr("number");
								errorObject["baxideCode"] = $(this).attr("code");
								errorObject["baxideDescription"] = $(this).attr("description");
								errorObject["baxideText"] = $(this).text();
								errorObject.isBaxideError = true;
							});

						} else {
							if (baxide.xmlHttp.responseText) {
								errorObject["baxideText"] = baxide.xmlHttp.responseText;

							}
						}
						deferred.reject(errorObject);
						return deferred;
					}

				}
			} else {
				received = false;
			}
			return;
		}
		//implment timeout if server is not responding
		var t = setTimeout(function () {
				if (received == false) {
					alert("Timed out!!!");
					var errorObject = {};
					errorObject["httpErrorText"] = "Timeout error occurred. Couldn't contact the server. Please, try again later.";
					errorObject.isHTTPError = true;
					this.xmlHttp.abort();
					timeoutVal = timeoutVal * 2;
					deferred.reject(errorObject);

					return deferred;
				}
			}, timeoutVal);
		this.xmlHttp.send(data);
		return deferred;
	}

	baxide.invokeGet = function (method, id, url) {
		if (tvYear == "2011") {
			return baxide.invokeGetMaple(method, id, url);
		}

		var timeSent;
		var deferred = $jq.Deferred();
		$.ajax({
			type : 'GET',
			async : true,
			cache : false,
			contentType : 'text/xml; charset=utf-8',
			dataType : 'xml',
			processData : false,
			url : this.host + (url ? url : method + "/" + id),
			username : username,
			timeout : timeoutVal,
			password : password,
			beforeSend : function (xhr) {
				xhr.setRequestHeader("Content-Type", 'text/xml; charset=utf-8');
				xhr.setRequestHeader('X-Requested-with', 'XMLHttpRequest');
				now = new Date();
				timeSent = now.getTime();
				//view.addDebugStart("Calling " + method + " " + url);
			},
			success : function (data, textStatus, jqXHR) {
				deferred.resolve(data, textStatus, jqXHR);
				var successTime = new Date();
				jqXHR = null;
				//view.addDebugSuccess("Success " + method + " " + (successTime.getTime() - timeSent));
			},
			error : function (jqXHR, textStatus, errorThrown) {
				var errorObject = {};
				errorObject["httpErrorCode"] = jqXHR.status;
				errorObject["httpErrorText"] = errorThrown;
				if (jqXHR.responseXML) {
					$(jqXHR.responseXML).find("error").each(function () {
						errorObject["baxideNumber"] = $(this).attr("number");
						errorObject["baxideCode"] = $(this).attr("code");
						errorObject["baxideDescription"] = $(this).attr("description");
						errorObject["baxideText"] = $(this).text();
						errorObject.isBaxideError = true;
					});
				} else if (jqXHR.responseText) {
					errorObject["baxideText"] = jqXHR.responseText;
				}
				deferred.reject(errorObject);
				jqXHR = null;
			}
		});
		return deferred;
	}

	//INVOKE GET 2011
	baxide.invokeGetMaple = function (method, id, url) {
		var type = "GET";
		if (nonce == null) {
			baxide.setNonce();
		}
		var received = false;
		var timeSent;
		// var url = url ? url : method + "/" + id;
		var completeUrl = this.host + url;

		var deferred = $jq.Deferred();
		var h = baxide.getAuth(type, url, 'digest');
		if (this.xmlHttp2 != null) {
			this.xmlHttp2.destroy();

		}
		this.xmlHttp2 = new XMLHttpRequest();
		this.xmlHttp2.open('GET', completeUrl, true);
		this.xmlHttp2.setRequestHeader("Content-Type", 'text/xml; charset=utf-8');
		this.xmlHttp2.setRequestHeader('Accept', 'application/xml, text/xml, */*');
		this.xmlHttp2.setRequestHeader('Accept-Encoding', 'gzip, deflate');
		this.xmlHttp2.setRequestHeader('SOAPAction', method);
		this.xmlHttp2.setRequestHeader('X-Requested-with', 'XMLHttpRequest');
		this.xmlHttp2.setRequestHeader('Pragma', 'no-cache');
		this.xmlHttp2.setRequestHeader('Cache-Control', 'no-cache');
		this.xmlHttp2.setRequestHeader('dataType', 'xml');
		this.xmlHttp2.setRequestHeader('processData', false);
		this.xmlHttp2.setRequestHeader('async', true);
		this.xmlHttp2.setRequestHeader('cache', false);
		this.xmlHttp2.setRequestHeader('url', url);
		this.xmlHttp2.setRequestHeader('Authorization', h);

		this.xmlHttp2.onreadystatechange = function responseMessage()
		{
			if (baxide.xmlHttp2.readyState >= 4) {
				received = true;
				if (baxide.xmlHttp2.status == 200) {
					deferred.resolve(baxide.xmlHttp2.responseXML, baxide.xmlHttp2.getResponseHeader('statusText'), baxide.xmlHttp2);
					//baxide.xmlHttp2.destroy();
					//baxide.xmlHttp2 = null;
					//	return deferred;
				} else {
					if (baxide.xmlHttp2.status == 401) {

						baxide.setNonce(baxide.xmlHttp2.getResponseHeader('WWW-Authenticate'));
						h = baxide.getAuth(type, url, 'digest');

						if (baxide.xmlHttp2 != null) {
							baxide.xmlHttp2.destroy();
						}
						baxide.xmlHttp2 = new XMLHttpRequest();
						baxide.xmlHttp2.open('GET', completeUrl, true);
						baxide.xmlHttp2.setRequestHeader('Accept', 'application/xml, text/xml, */*');
						baxide.xmlHttp2.setRequestHeader('Accept-Encoding', 'gzip, deflate');
						baxide.xmlHttp2.setRequestHeader('Accept-Language', 'en');
						baxide.xmlHttp2.setRequestHeader("Content-Type", 'text/xml; charset=utf-8');
						baxide.xmlHttp2.setRequestHeader('X-Requested-with', 'XMLHttpRequest');
						baxide.xmlHttp2.setRequestHeader('Pragma', 'no-cache');
						baxide.xmlHttp2.setRequestHeader('Cache-Control', 'no-cache');
						baxide.xmlHttp2.setRequestHeader('dataType', 'xml');
						baxide.xmlHttp2.setRequestHeader('processData', false);
						baxide.xmlHttp2.setRequestHeader('async', true);
						baxide.xmlHttp2.setRequestHeader('cache', false);
						baxide.xmlHttp2.setRequestHeader('url', url);
						baxide.xmlHttp2.setRequestHeader('Authorization', h);

						baxide.xmlHttp2.onreadystatechange = function response2Message() {
							if (baxide.xmlHttp2.readyState >= 4) {
								received = true;
							} else {
								received = false;
							}
							if (baxide.xmlHttp2.readyState == 4) {
								if (baxide.xmlHttp2.status == 200) {
									var textStatus = baxide.xmlHttp2.getResponseHeader('statusText');
									deferred.resolve(baxide.xmlHttp2.responseXML, textStatus, baxide.xmlHttp2);
									//baxide.xmlHttp2.destroy();
									//baxide.xmlHttp2 = null;
									return deferred;
								} else {
									//received = false;
									deferred.reject();
									//baxide.xmlHttp2 = null;
									return deferred;
								}
							}

						}
						var t = setTimeout(function () {
								if (received == false) {
									alert("Timed out!!!");
									var errorObject = {};
									errorObject["httpErrorText"] = "Timeout error occurred. Couldn't contact the server. Please, try again later.";
									errorObject.isHTTPError = true;
									baxide.xmlHttp2.abort();
									timeoutVal = timeoutVal * 2;
									deferred.reject(errorObject);
									//baxide.xmlHttp2 = null;

									return deferred;
								}
							}, timeoutVal);
						received = false;
						baxide.xmlHttp2.send();

					}
				}

			} else {
				received = false;
			}
			return;
		}
		var t = setTimeout(function () {
				if (received == false) {
					alert("Timed out!!!");
					var errorObject = {};
					errorObject["httpErrorText"] = "Timeout error occurred. Couldn't contact the server. Please, try again later.";
					errorObject.isHTTPError = true;
					this.xmlHttp2.abort();
					timeoutVal = timeoutVal * 2;
					deferred.reject(errorObject);
					this.xmlHttp2 = null;

					return deferred;
				}
			}, timeoutVal);
		this.xmlHttp2.send();
		return deferred;
	}

	/**
	 * Invoke the baxide servers through a REST request.
	 * NOTE FUNCTION IS UNTESTED
	 *
	 * @param String url
	 * the url to the service to be used
	 *
	 * @param String body
	 * data to send to server
	 *
	 * @param String type (optional)
	 * type of call to make ie. POST, GET
	 *
	 * @param String contentType (optional)
	 * content-type
	 *
	 * @return Deferred
	 * A jQuery Deferred object
	 */

	baxide.restInvoke = function (url, payload, type, contentType) {
		if (tvYear == "2011") {
			return baxide.restInvokeMaple(url, payload, type, contentType);
		}
		if (url.indexOf("http://") == -1 && url.indexOf("https://") == -1) {
			url = baxide.host + url;
		}
		if (!type) {
			type = 'POST';
		}
		if (!contentType) {
			contentType = 'application/xml; charset=utf-8';
		}
		var timeSent;

		var deferred = $jq.Deferred();
		$.ajax({
			type : type,
			async : true,
			cache : false,
			contentType : contentType,
			dataType : 'text',
			processData : false,
			url : url,
			username : username,
			timeout : timeoutVal,
			password : password,
			data : payload,
			beforeSend : function (xhr) {
				now = new Date();
				timeSent = now.getTime();
				//view.addDebugStart("restInvoke " + url);
			},
			success : function (data, textStatus, jqXHR) {
				deferred.resolve(data, textStatus, jqXHR);
				var successTime = new Date();
				//view.addDebugSuccess("Success " + (successTime.getTime() - timeSent));
			},
			error : function (jqXHR, textStatus, errorThrown) {
				var errorObject = {};
				errorObject["httpErrorCode"] = jqXHR.status;
				errorObject["httpErrorText"] = errorThrown;
				errorObject.isHTTPError = true;
				if (jqXHR.responseXML) {
					$(jqXHR.responseXML).find("error").each(function () {
						errorObject["baxideNumber"] = $(this).attr("number");
						errorObject["baxideCode"] = $(this).attr("code");
						errorObject["baxideDescription"] = $(this).attr("description");
						errorObject["baxideText"] = $(this).text();
						errorObject.isBaxideError = true;
					});
				} else if (jqXHR.responseText) {
					errorObject["baxideText"] = jqXHR.responseText;
				}
				deferred.reject(errorObject);
			}
		});
		return deferred;
	}

	// Rest invoke for 2011 tv
	baxide.restInvokeMaple = function (url, payload, type, contentType) {
		if (url.indexOf("http://") == -1) {
			url = baxide.host + "/v1/" + url;
			url = url.replace("http", "https");
		}

		if (!type) {
			type = 'POST';
		}
		if (!contentType) {
			contentType = 'application/xml; charset=utf-8';
		}
		var timeSent;
		var received = false;

		var deferred = $jq.Deferred();
		var h = baxide.getAuth(type, url, 'digest');
		if (this.xmlHttp != null) {
			this.xmlHttp.destroy();
		}
		this.xmlHttp = new XMLHttpRequest();
		this.xmlHttp.open(type, url, true);
		this.xmlHttp.setRequestHeader("Content-Type", contentType);
		this.xmlHttp.setRequestHeader('Accept', 'application/xml, text/xml, */*');
		this.xmlHttp.setRequestHeader('Accept-Encoding', 'gzip, deflate');
		this.xmlHttp.setRequestHeader('X-Requested-with', 'XMLHttpRequest');
		this.xmlHttp.setRequestHeader('Pragma', 'no-cache');
		this.xmlHttp.setRequestHeader('Cache-Control', 'no-cache');
		this.xmlHttp.setRequestHeader('dataType', 'xml');
		this.xmlHttp.setRequestHeader('processData', false);
		this.xmlHttp.setRequestHeader('cache', false);
		//	this.xmlHttp.setRequestHeader('url', url);
		this.xmlHttp.setRequestHeader('Authorization', h);

		this.xmlHttp.onreadystatechange = function responseMessage() {

			if (baxide.xmlHttp.readyState >= 4) {
				received = true;
				if (baxide.xmlHttp.status == 200) {
					deferred.resolve(baxide.xmlHttp.responseXML, baxide.xmlHttp.getResponseHeader('statusText'), baxide.xmlHttp);

					if (baxide.xmlHttp.destroy) {
						//baxide.xmlHttp.destroy();
						//baxide.xmlHttp = null;
					}
					return deferred;
				} else {
					if (baxide.xmlHttp.status == 401) {

						baxide.setNonce(baxide.xmlHttp.getResponseHeader('WWW-Authenticate'));
						h = baxide.getAuth(type, url, 'digest');
						if (baxide.xmlHttp != null) {
							baxide.xmlHttp.destroy();
						}
						baxide.xmlHttp = new XMLHttpRequest();
						baxide.xmlHttp.open(type, url, true);
						baxide.xmlHttp.setRequestHeader('Accept', 'application/xml, text/xml, */*');
						baxide.xmlHttp.setRequestHeader('Accept-Encoding', 'gzip, deflate');
						baxide.xmlHttp.setRequestHeader('Accept-Language', 'en');
						baxide.xmlHttp.setRequestHeader("Content-Type", 'text/xml; charset=utf-8');
						baxide.xmlHttp.setRequestHeader('X-Requested-with', 'XMLHttpRequest');
						baxide.xmlHttp.setRequestHeader('Pragma', 'no-cache');
						baxide.xmlHttp.setRequestHeader('Cache-Control', 'no-cache');
						baxide.xmlHttp.setRequestHeader('dataType', 'xml');
						baxide.xmlHttp.setRequestHeader('processData', false);
						baxide.xmlHttp.setRequestHeader('cache', false);
						//	baxide.xmlHttp.setRequestHeader('url', url);
						baxide.xmlHttp.setRequestHeader('Authorization', h);

						baxide.xmlHttp.onreadystatechange = function response2Message() {
							if (baxide.xmlHttp.readyState >= 4) {
								received = true;
							} else {
								received = false;
							}
							if (baxide.xmlHttp.readyState == 4) {
								if (baxide.xmlHttp.status == 200) {
									var textStatus = baxide.xmlHttp.getResponseHeader('statusText');
									deferred.resolve(baxide.xmlHttp.responseXML, textStatus, baxide.xmlHttp);

									if (baxide.xmlHttp.destroy) {
										//baxide.xmlHttp.destroy();
										//baxide.xmlHttp = null;
									}
									return deferred;
								} else {
									//received = false;
									alert("Error 2: " + baxide.xmlHttp.status);
									deferred.reject();
									//baxide.xmlHttp = null;
									return deferred;
								}
							}

						}
						var t = setTimeout(function () {
								if (received == false) {
									alert("Timed out!!!");
									var errorObject = {};
									errorObject["httpErrorText"] = "Timeout. Couldn't contact the server. Please, try again later.";
									errorObject.isHTTPError = true;
									baxide.xmlHttp.abort();
									timeoutVal = timeoutVal * 2;
									deferred.reject(errorObject);
									//baxide.xmlHttp = null;

									return deferred;
								}
							}, timeoutVal);
						received = false;
						baxide.xmlHttp.send(payload);
					} else {
						if (baxide.xmlHttp.readyState == 4) {
							if (baxide.xmlHttp.status == 204) {
								deferred.resolve(baxide.xmlHttp.responseXML, baxide.xmlHttp.getResponseHeader('statusText'), baxide.xmlHttp);
							} else {
								var errorObject = {};
								errorObject["httpErrorCode"] = baxide.xmlHttp.status;
								deferred.reject(errorObject);

							}

							if (baxide.xmlHttp.destroy) {
								//baxide.xmlHttp.destroy();
								//baxide.xmlHttp = null;
							}
							return deferred;
						}

					}
				}
			} else {
				received = false;
			}
			return;
		}
		var t = setTimeout(function () {
				if (received == false) {
					alert("Timed out!!!");
					var errorObject = {};
					errorObject["httpErrorText"] = "Timeout. Couldn't contact the server. Please, try again later.";
					errorObject.isHTTPError = true;
					baxide.xmlHttp.abort();
					timeoutVal = timeoutVal * 2;
					deferred.reject(errorObject);
					//baxide.xmlHttp = null;

					return deferred;
				}
			}, timeoutVal);
		baxide.xmlHttp.send(payload);
		return deferred;
	}

	baxide.playqueuePosition = function (method) {
		if (tvYear == "2012") {
			$.ajax({
				type : method,
				async : true,
				cache : false,
				contentType : 'text/plain; charset=UTF-8',
				processData : false,
				url : this.host + "/v1/users/" + states.userId + "/config/cloudmeweb/playqueue;position",
				username : username,
				timeout : timeoutVal,
				password : password,
				data : currentAudio,
				beforeSend : function (xhr) {
					xhr.setRequestHeader('X-Requested-with', 'XMLHttpRequest');
				},
				success : function (data, textStatus, jqXHR) {
					if (method == "GET")
						currentAudio = parseInt(data);
					jqXHR = null;
				},
				error : function (jqXHR, textStatus, errorThrown) {
					var errorObject = {};
					errorObject["httpErrorCode"] = jqXHR.status;
					errorObject["httpErrorText"] = errorThrown;
					if (jqXHR.responseXML) {
						$(jqXHR.responseXML).find("error").each(function () {
							errorObject["baxideNumber"] = $(this).attr("number");
							errorObject["baxideCode"] = $(this).attr("code");
							errorObject["baxideDescription"] = $(this).attr("description");
							errorObject["baxideText"] = $(this).text();
							errorObject.isBaxideError = true;
						});
					} else if (jqXHR.responseText) {
						errorObject["baxideText"] = jqXHR.responseText;
					}
					jqXHR = null;
				}
			});
		} else {
			var h = baxide.getAuth(method, "/v1/", 'digest');
			var xmlHttpPos = new XMLHttpRequest();
			xmlHttpPos.open(method, this.host + "/v1/users/" + states.userId + "/config/cloudmeweb/playqueue;position", true);

			xmlHttpPos.setRequestHeader("Content-Type", 'text/plain; charset=UTF-8');
			xmlHttpPos.setRequestHeader('X-Requested-with', 'XMLHttpRequest');
			xmlHttpPos.setRequestHeader('async', true);
			xmlHttpPos.setRequestHeader('Authorization', h);
			xmlHttpPos.onreadystatechange = function responseMessage() {

				if (xmlHttpPos.readyState == 4 && xmlHttpPos.status == 200 && method == "GET") {
					currentAudio = parseInt(xmlHttpPos.responseText);
					xmlHttpPos.destroy();
				}
				if (xmlHttpPos.readyState == 4 && method == "PUT") {
					xmlHttpPos.destroy();
				}
			}
			xmlHttpPos.send(currentAudio + "");
		}
	}

	//get nonce value from server and store in nonce variable for future requests
	baxide.setNonce = function (authResponseHeader) {
		var auth;
		//	h = "Basic "+btoa(username+":"+password);
		if (authResponseHeader == null) {
			if (this.xmlHttp != null) {
				this.xmlHttp.destroy();
			}
			this.xmlHttp = new XMLHttpRequest();
			this.xmlHttp.open('GET', host + '/v1/', false);
			this.xmlHttp.onreadystatechange = function responseMessage() {
				if (baxide.xmlHttp.readyState == 4 && baxide.xmlHttp.status == 401) {
					auth = baxide.xmlHttp.getResponseHeader('WWW-Authenticate');
					if (baxide.xmlHttp.destroy) {
						//baxide.xmlHttp.destroy();
						//baxide.xmlHttp = null;
					}
				}
			}
			/*		this.xmlHttp.timeout = 60000;
			this.xmlHttp.ontimeout = function () {
			alert("Timed out!!!");

			if (this.xmlHttp.destroy) {
			this.xmlHttp.destroy();
			this.xmlHttp = null;
			}
			baxide.setNonce(authResponseHeader);
			}*/
			this.xmlHttp.send();
		} else {
			auth = authResponseHeader;
		}
		if (auth != undefined) {
			var authArr = auth.split(",");
			nonceVal = authArr[2].split("e=")[1];
			nonceVal.split('"')[1];
			nonce = nonceVal.split('"')[1];

		} else {
			auth = null;
		}
	}

	//get authentication header
	baxide.getAuth = function (type, url, authType) {
		if (authType == 'digest') {
			ha1 = utils.MD5(username + ":os@xcerion.com:" + password);
			ha2 = utils.MD5(type + ":" + url);
			response = utils.MD5(ha1 + ":" + nonce + ":00000001:082c875dcb2ca740:auth:" + ha2);
			h = 'Digest username="' + username + '", realm="os@xcerion.com", nonce="' + nonce + '", uri="' + url + '", algorithm=MD5, response="' + response + '", qop=auth, nc=00000001, cnonce="082c875dcb2ca740"';
		} else {
			h = "Basic " + btoa(username + ":" + password);
		}
		//		alert("h: "+h);
		return h;
	}

	// generate the url, adding the username and password or the session, to the get requests ( for images, music and video)
	baxide.generateUrl = function (url) {
		//		if(url.indexOf("www.cloudme.com") == -1)
		//		if(url.indexOf("file://") != -1) url = url.replace("file://","https://");
		//		if(url.indexOf("http://") != -1) url = url.replace("http://","https://");
		if (tvYear == "2011" || host.indexOf("https://") != -1) { //If 2011 tv, use https and session
			if (url.indexOf("file://") != -1)
				url = url.replace("file://", "http://");
			if (url.indexOf("https://") == -1)
				url = url.replace("http", "https");
			if (url.indexOf("?") == -1) {
				url = url + "?session=" + baxide.session; //+session;
			} else {
				url = url + "&session=" + baxide.session; //+session;
			}
			//	url = url.replace(/ /g,"%20");

		} else { // if 2012, use username and password at server
			var credentials = username + ":" + password + "@";
			if (url.indexOf("file://") != -1)
				url = url.replace("file://", "http://");
			if (url.indexOf("https://") != -1)
				url = url.replace("https", "http");
			if (url.indexOf("https://") != -1) {
				url = url.substr(0, 8) + credentials + url.substr(8);
			} else {
				url = url.substr(0, 7) + credentials + url.substr(7);
			}

			//	url = url.replace(/ /g,"_");
		}
		url = url.replace(/ /g, "%20");
		//		alert("link after: "+url);
		return url;
	}

}

baxide.setHost = function (host) {
	this.host = host;
}

baxide.setSession = function (session) {
	this.session = session;
}

baxide.soap = function (xml) {
	return '<SOAP-ENV:Envelope xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/" ' +
	'SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/">' +
	'<SOAP-ENV:Body>' + xml + '</SOAP-ENV:Body></SOAP-ENV:Envelope>';
}

baxide.unSOAP = function (doc) {

	if (typeof doc == "string") {

		var p1 = doc.indexOf("<SOAP-ENV:Body>");
		p1 = p1 + 15;
		//		alert(p1);
		var p2 = doc.indexOf("</SOAP-ENV:Body>");
		//		alert(p2);
		var domParser = new DOMParser();
		var docString = '<?xml version="1.0" encoding="utf-8"?>' + doc.substring(p1, p2);
		//		alert(docString);
		var newDoc = domParser.parseFromString(docString, "application/xml");
		//		alert(newDoc);
		return newDoc;
	}
	var newRoot = $(doc).children().children().children()[0];
	doc.replaceChild(newRoot, doc.documentElement);
	return doc;
}

/**
 * Generates the payload from method name and the params object.
 * The object must follow the following rules:
 *
 *    params["folderId"] = "123";
 *  result:
 *    <folder id='123'/>
 *
 *    params["document"] = "settings.xml";
 *  result:
 *    <document>settings.xml</document>
 *
 * The method name will be used as the root node on the
 * request so for example:
 *
 * var params = [];
 * params["folderId"] = "123";
 * params["document"] = "settings.xml";
 * baxide.createPostBody("loadDocument", params);
 *
 * Will generate a soap request:
 *  <loadDocument><folder id='123'/><document>settings.xml</document></loadDocument>
 */
baxide.createPostBody = function (method, params, id) {
	function createString(k, v) {
		if (k.indexOf("Id") != -1) {
			return '<' + k.substring(0, k.length - 2) + ' id="' + baxide.entityify(v) + '"/>';
		} else {
			return '<' + k + '>' + baxide.entityify(v) + '</' + k + '>';
		}
	}
	var payload;
	if (params) {
		payload = '<' + method + '>';
		for (var key in params) {
			var value = params[key];
			if (value && typeof value == "object" & $.isArray(value)
				/*value.constructor && value.constructor.toString() == Array.toString()*/
			)
			{
				// it's an array
				var len = value.length;
				for (i = 0; i < len; i++) {
					payload += createString(key, value[i]);
				}
			} else {
				payload += createString(key, value);
			}
		}
		payload += '</' + method + '>';
	} else {
		payload = '<' + method + '/>';
	}
	return payload;
}

baxide.entityify = function (str) {
	if (typeof(str) == "string") {
		return str.replace(/&/g, "&amp;").replace(/</g, "&lt;").replace(/>/g, "&gt;");
	} else {
		return str;
	}
}
