var widgetAPI = new Common.API.Widget();

function SceneLoginScene(options) {
	this.options = options;
	var ime_plainText = null;
	var ime_passwordText = null;
	var elementPassword;
	var elementPlain;
}

SceneLoginScene.prototype.initialize = function () {
	alert("SceneLoginScene.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here
	// scene HTML and CSS will be loaded before this function is called
	$('p#username').html(STR_USERNAME);
	$('p#pwd').html(STR_PASSWORD);
	$('#keepLogin_text').html(STR_KEEP_SIGNED);
	$('#secure_text').html(STR_SECURE);

	var xPosition;
	switch (sf.env.getResolution()) {
	case '540p':
		xPosition = 600;
		break;
	case '720p':
		xPosition = 850;
		break;
	case '1080p':
		xPosition = 1050;
		break;
	}

	ime_plainText = new IMEShell("plainText", callback_plainText, "en");
	ime_passwordText = new IMEShell("passwordText", callback_passwordText, "en");
	ime_plainText.setKeypadPos(xPosition, 100, 9);
	ime_passwordText.setKeypadPos(xPosition, 100, 9);
	elementPlain = document.getElementById("plainText");
	elementPassword = document.getElementById("passwordText");

	$('#SceneLogin #login_button').sfButton({
		text : STR_SIGN_IN
	});
	$('#SceneLogin #createAccountScene_button').sfButton({
		text : STR_CREATE_ACCOUNT
	});
	$('#SceneLogin #keeplogin_checkbox').sfCheckBox('uncheck');
	$('#SceneLogin #secure_checkbox').sfCheckBox('uncheck');
	var lang = sf.core.getEnvValue('lang') || sf.env.getLanguageCode() || deviceapis.tv.info.getLanguage();
	if(lang == "es" || lang == "es-US" )
		$('#SceneLogin #keeplogin_checkbox').css('left','225px');
}

SceneLoginScene.prototype.handleShow = function () {
	alert("SceneLoginScene.handleShow()");
	// this function will be called when the scene manager show this scene

	ime_plainText.setString("");
	ime_passwordText.setString("");

	$('#svecKeyHelp_login').sfKeyHelp({
		'enter' : STR_SELECT,
		'leftright' : STR_LEFT_RIGHT,
		'updown' : STR_UP_DOWN,
		'return' : STR_EXIT
	});
	widgetAPI.sendReadyEvent();
}

SceneLoginScene.prototype.handleHide = function () {
	alert("SceneLoginScene.handleHide()");
	// this function will be called when the scene manager hide this scene
}

SceneLoginScene.prototype.handleFocus = function () {
	alert("SceneLoginScene.handleFocus()");
	// this function will be called when the scene manager focus this scene

	document.getElementById("plainText").focus(); //focus the plain Text
	bootingTimeEnd = new Date().getTime();
	alert("Booting time: " + (bootingTimeEnd - bootingTimeInitial) + " milliseconds");

}

SceneLoginScene.prototype.handleBlur = function () {
	alert("SceneLoginScene.handleBlur()");
	//sf.scene.hide("LoginScene");
	if (document.getElementById("elementPassword") != null) {
		document.getElementById("elementPassword").blur()
	};
	if (document.getElementById("elementPlain") != null) {
		document.getElementById("elementPlain").blur()
	};
	sf.scene.returnFocus();
	// this function will be called when the scene manager move focus to another scene from this scene
}

SceneLoginScene.prototype.handleKeyDown = function (keyCode) {
	alert("SceneLoginScene.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued


	switch (keyCode) {
	case sf.key.LEFT:
		if (($("#createAccountScene_button").is(".sf-ui-button-focus"))) {
			$('#SceneLogin #createAccountScene_button').sfButton('blur');
			document.getElementById("passwordText").focus();
		} else {
			if ($("#login_button").is(".sf-ui-button-focus")) {
				$('#SceneLogin #login_button').sfButton('blur');
				document.getElementById("plainText").focus();
			} else {
				$('#SceneLogin #secure_checkbox').sfCheckBox('blur');
				$('#SceneLogin #keeplogin_checkbox').sfCheckBox('focus');
			}
		}
		break;
	case sf.key.RIGHT:
		if (($("#keeplogin_checkbox").is(".sf-ui-checkbox-focused"))) {
			$('#SceneLogin #keeplogin_checkbox').sfCheckBox('blur');
			$('#SceneLogin #login_button').sfButton('focus');
		}
		break;
	case sf.key.UP:
		if (($("#keeplogin_checkbox").is(".sf-ui-checkbox-focused"))) {
			$('#SceneLogin #keeplogin_checkbox').sfCheckBox('blur');
			document.getElementById("passwordText").focus();
		} else {
			if ($("#login_button").is(".sf-ui-button-focus")) {
				$('#SceneLogin #login_button').sfButton('blur');
				$('#SceneLogin #keeplogin_checkbox').sfCheckBox('focus');
			} else {
				if ($("#secure_checkbox").is(".sf-ui-checkbox-focused")) {
					$('#SceneLogin #secure_checkbox').sfCheckBox('blur');
					$('#SceneLogin #createAccountScene_button').sfButton('focus');
				} else {
					$('#SceneLogin #login_button').sfButton('focus');
					$('#SceneLogin #createAccountScene_button').sfButton('blur');
				}
			}
		}
		break;
	case sf.key.DOWN:
		if (($("#keeplogin_checkbox").is(".sf-ui-checkbox-focused"))) {
			$('#SceneLogin #keeplogin_checkbox').sfCheckBox('blur');
			$('#SceneLogin #login_button').sfButton('focus');
		} else {
			if ($("#login_button").is(".sf-ui-button-focus")) {
				$('#SceneLogin #login_button').sfButton('blur');
				$('#SceneLogin #createAccountScene_button').sfButton('focus');
			} else {
				if ($("#createAccountScene_button").is(".sf-ui-button-focus")) {
					$('#SceneLogin #createAccountScene_button').sfButton('blur');
					$('#SceneLogin #secure_checkbox').sfCheckBox('focus');
				} else {
					if (!($("#createAccountScene_button").is(".sf-ui-button-focus"))) {
						document.getElementById("elementPassword").blur();
						$('#SceneLogin #keeplogin_checkbox').sfCheckBox('focus');

					}
				}
			}
		}
		break;
	case sf.key.ENTER:
		if ($("#SceneLogin #createAccountScene_button").is(".sf-ui-button-focus")) {
			//go to sign up scene

			$('#SceneLogin #createAccountScene_button').sfButton('blur');
			controller.goToSignUpScene();

		} else {
			var keep_logged;
			var secure;
			if ($("#login_button").is(".sf-ui-button-focus")) {

				if (check_username_and_password_not_empty()) {
					if (check_network_connected()) {
						loginTimeInitial = new Date().getTime();
						$('#loading').sfLoading('show');
						$('#SceneLogin #login_button').sfButton('blur');
						SceneLoginScene.submit_button = 0;
						//alert("username =  "+elementPlain.value.toLowerCase());
						//alert("pass =  "+elementPassword.value);

						var username = elementPlain.value.toLowerCase();
						var password = elementPassword.value;

						keep_logged = $('#SceneLogin #keeplogin_checkbox').sfCheckBox('getChecked');
						secure = $('#SceneLogin #secure_checkbox').sfCheckBox('getChecked');

						if (secure) {
							host = "https://www.cloudme.com";
						} else {
							host = "http://www.cloudme.com";
						}
						alert("secure " + secure + "   host " + host);
						//Do Login
						controller.handleLogin(username, password, keep_logged);
					} else {
						show_network_error_popup();
					}
				}
			}
			if ($("#keeplogin_checkbox").is(".sf-ui-checkbox-focused")) {
				keep_logged = $('#SceneLogin #keeplogin_checkbox').sfCheckBox('getChecked');
				if (keep_logged) {
					$('#SceneLogin #keeplogin_checkbox').sfCheckBox('uncheck');
				} else {
					$('#SceneLogin #keeplogin_checkbox').sfCheckBox('check');
				}
			}
			if ($("#secure_checkbox").is(".sf-ui-checkbox-focused")) {
				secure = $('#SceneLogin #secure_checkbox').sfCheckBox('getChecked');
				if (secure) {
					$('#SceneLogin #secure_checkbox').sfCheckBox('uncheck');
				} else {
					$('#SceneLogin #secure_checkbox').sfCheckBox('check');
				}
			}
		}
		break;
	case sf.key.RETURN:
		alert("RETURN PRESSED");
		break;

	}
}

function callback_plainText(cb) {
	alert("callback_plainText(" + cb + ")");
	//set the key functions when the plainText is focused
	//widgetAPI.blockNavigation(sf.key.RETURN);
	cb.setKeyFunc(sf.key.RETURN, function (keyCode) {
		handle_return();
		return false;
	})
	cb.setKeyFunc(sf.key.DOWN, function (keyCode) {
		alert('document.getElementById("passwordText")' + document.getElementById("passwordText"));
		document.getElementById("passwordText").focus();
		return false;
	});
	cb.setKeyFunc(sf.key.ENTER, function (keyCode) {
		alert("enter plain");
		document.getElementById("passwordText").focus();
		return false;
	});
	cb.setKeyFunc(sf.key.RIGHT, function (keyCode) {
		$("#plainText").blur();
		sf.scene.returnFocus();
		$('#SceneLogin #login_button').sfButton('focus');
		return false;
	});
	cb.setKeyFunc(sf.key.EXIT, function (keyCode) {
		widgetAPI.sendExitEvent();
		return false;
	});
}

function callback_passwordText(cb) {
	alert("callback_passwordText(" + cb + ")");
	//set the key functions when the passwordText is focused
	cb.setKeyFunc(sf.key.UP, function (keyCode) {
		document.getElementById("plainText").focus();
		return false;
	});
	cb.setKeyFunc(sf.key.DOWN, function (keyCode) {
		$("#passwordText").blur();
		sf.scene.returnFocus();
		$('#SceneLogin #keeplogin_checkbox').sfCheckBox('focus');
		return false;
	}); // $("#passwordText").blur(); sf.scene.returnFocus();  $('#SceneLogin #login_button').sfButton('focus'); } );
	cb.setKeyFunc(sf.key.ENTER, function (keyCode) {
		alert("enter pass");
		$("#passwordText").blur();
		sf.scene.returnFocus();
		$('#SceneLogin #login_button').sfButton('focus');
		return false;
	});
	cb.setKeyFunc(sf.key.RIGHT, function (keyCode) {
		$("#passwordText").blur();
		sf.scene.returnFocus();
		$('#SceneLogin #login_button').sfButton('focus');
		return false;
	});
	cb.setKeyFunc(sf.key.RETURN, function (keyCode) {
		handle_return();
		return false;
	})
	cb.setKeyFunc(sf.key.EXIT, function (keyCode) {
		widgetAPI.sendExitEvent();
		return false;
	});

}
//SceneLoginScene.submit_button = 1;
function handle_return() {
	alert("handling return");
	//sf.scene.returnFocus(); // triggers the closing of the IME Plugin
	$("#plainText").blur();
	$("#passwordText").blur();

	//set focus to any other element
	SceneLoginScene.submit_button = 1;
	$('#SceneLogin #login_button').sfButton('focus');
}

function check_username_and_password_not_empty() {
	if (elementPlain.value == null || elementPlain.value == "") {
		alert("Username can't be blank");

		//show popup
		$('#login_error_popup').sfPopup({
			text : "Username can't be blank",
			buttons : "OK",
			callback : function logoutCallback() {

				$('#SceneLogin #login_button').sfButton('focus');

			}
		});
		$('#login_error_popup').sfPopup('show');

		return false
	}
	if (elementPassword.value == null || elementPassword.value == "") {
		alert("Password can't be blank");

		//Show popup
		$('#login_error_popup').sfPopup({
			text : "Password can't be blank",
			buttons : "OK",
			callback : function logoutCallback() {

				$('#SceneLogin #login_button').sfButton('focus');

			}
		});
		$('#login_error_popup').sfPopup('show');

		return false
	}
	return true;
}

function check_network_connected() {
	var physicalConnection = 0;
	var httpStatus = 0;

	// Get active connection type - wired or wireless.
	var currentInterface = networkPlugin.GetActiveType();

	// If no active connection.
	if (currentInterface === -1) {
		return false;
	}

	// Check physical connection of current interface.
	physicalConnection = networkPlugin.CheckPhysicalConnection(currentInterface);

	// If not connected or error.
	if (physicalConnection !== 1) {
		return false;
	}

	// Check HTTP transport.
	httpStatus = networkPlugin.CheckHTTP(currentInterface);

	// If HTTP is not avaliable.
	if (httpStatus !== 1) {
		return false;
	}

	// Everything went OK.
	return true;
}

show_network_error_popup = function () {
	$('#login_error_popup').sfPopup({
		text : "You are not connected. Plese check your network connection",
		buttons : "OK",
		callback : function logoutCallback() {

			$('#SceneLogin #login_button').sfButton('focus');

		}
	});
	$('#login_error_popup').sfPopup('show');

}

SceneLoginScene.loginFailed = function (msg) {
	alert("login failed: " + msg);
	if (msg == null || msg == "")
		msg = "Couldn't contact the server. Check your network connection";

	$('#login_error_popup').sfPopup({
		text : "Failed to Login: " + msg,
		timeout : 0,
		buttons : "OK",
		callback : function logoutCallback() {

			$('#SceneLogin #login_button').sfButton('focus');

		}
	});
	$('#login_error_popup').sfPopup('show');
}
